%: This file contains the 14 scalars of a 4-dimensional riemannian space
%: as given by V. V. Narlikar and K. R. Karmarkar in Proc. Indian Acad.
%: Sci., v. A29, 91-97 (1949).  A more accessible reference containing
%: expressions for these scalars is contained in the paper by K. P. Singh
%: and D. N. Singh, Mon. Not. R. astr. Soc., v. 140, 453-460 (1968).
%:
%: Before using this file it may be desireable to (LOADEF CORD) first>
 
%: This file was written by Alex Harvey, harvey@acf4.nyu.edu

(LOADEF CORD)

(PDEF NKI1 R) <RSCL>$

(PDEF RICU R) <RICC A ~B>$

(PDEF NKI2 R) <RICU A B><RICU B A>$

(PDEF NKI3 R) <RICU A B><RICU B C><RICU C A>$

(PDEF NKI4 R) <RICU A B><RICU B C><RICU C D><RICU D A>$

(PDEF NKA A SA12A34) <WEYL A B C D><WEYL E F G H><GUU C E><GUU D F>$

(PDEF NKB B SA12A34) <WEYL A B C D><NKA E F G H><GUU C E><GUU D F>$

(PDEF GSK X SA12A34) <GDD A [B><GDD C [D>$

(PDEF NKJ1 J1) <NKA A B C D><GUU A C><GUU B D>$

(PDEF NKJ2 J2) <NKB A B C D><GUU A C><GUU B D>


%: EOF
