#%:hlp MAKEFILE.      ******  Makefile to compile and make STENSOR  ******%:up

#%:h%:up        Situate yourself on this subdirectory. Then do:
#%:h%:up         On VMS:    unix make stensor   (-or dito:  cstensor)
#%:h%:up         On UNIX:        make stensor   (-or:  make cstensor)
#          (-or,to debug:     ...make -n stensor  -to N-ot really do, just see)
#%:h%:up       Lines below marked %:UNIX/VMS need editing on a UNIX-machine!
#%:unix%:up    Similarly edit those lines in MAKEFILE. for SLISP and SHEEP!!

#%:up        **** Below presumes the dir-hierarchy that was on tape !! ****
TopDir =../..# Go UP (../) a dir. There exe-files. Changed?  %:up
ShpDir =../..# This too is just above stssrc,unless changed.           %:up
StsSrc =${TopDir}/stssrc#   STSsrc itself
StsLib =${TopDir}/stslib
StsLog =./log#               Logging below here (cu..)
ShpLib =${TopDir}/shplib#   Sister to STSsrc. Change?    BLOCK BELOW=SHEEP
SlspDir =${TopDir}#           Change this appropriately
SlLib =${SlspDir}/sllib#   Change this appropriately
EXE =#    This is for %:UNIX             %:up  Put commentchar # if %:VMS, or
#EXE =.exe# This is for%:VMS under EUNICE %:up  -at start of either line!%:UNIX
# To avoid the error: "ISD VBN greater than header block count" on %:VMS:
Mv =${SlLib}/mvexe# This is a temprary fix for EUNICE under%:VMS4. %:UnixPut#
#Mv =mv#              On %:UNIX do not use fix just move.           %:Vms put #
Quiet =#q#            q for non verbose compilation

SlIma = ${TopDir}/slisp
ShpIma = ${TopDir}/psheep
RhpIma = ${TopDir}/rsheep
StsIma = ${TopDir}/pstensor
RtsIma = ${TopDir}/rtensor
CStsIma = ${TopDir}/cstensor
IStsIma = ${TopDir}/istensor
NStsIma = ${TopDir}/nstensor
ClaIma = ${TopDir}/classi
ShpRoot = ${ShpIma}/LISPROOT
RhpRoot = ${RhpIma}/LISPROOT
StsRoot = ${StsIma}/LISPROOT
RtsRoot = ${RtsIma}/LISPROOT
CStsRoot = ${CStsIma}/LISPROOT
IStsRoot = ${IStsIma}/LISPROOT
NStsRoot = ${NStsIma}/LISPROOT
NRtsRoot = ${NRtsIma}/LISPROOT
ClaRoot = ${ClaIma}/LISPROOT

${StsIma}:
	-mkdir ${StsIma}

${RtsIma}:
	-mkdir ${RtsIma}

${CStsIma}:
	-mkdir ${CStsIma}

${IStsIma}:
	-mkdir ${IStsIma}

${NStsIma}:
	-mkdir ${NStsIma}

Lisp    = /usr/hlh/lisp# Basic Cambridge Lisp. Image to be provided.
RunLisp = ${TopDir}/catcherr# Script to make Cambridige Lisp return 0 when ok
SavSheep = ${RunLisp} 200 204 ${Lisp} -I
ShpFap =${RunLisp} "0" 4 ${Lisp} -I ${ShpIma} -G sfap
DoCref = ${RunLisp} "0" 4 ${Lisp} -I ${SlIma} -G rcref \
         -f ${SlLib}/islisp.fns -ymZWpFf loadcrf.sl
ShpCref = ${RunLisp} 0 4 ${Lisp} -I ${ShpIma} -G rcref \
	 -Yf ${SlLib}/islisp.fns -yf ${ShpLib}/isheep.fns -ypFnf loadcrf.sts
StsCref = ${RunLisp} 0 4 ${Lisp} -I ${ShpIma} -G rcref \
	 -Yf ${SlLib}/islisp.fns -yf ${ShpLib}/isheep.fns -ypFnf cldcrf.sl

# ignore ANaLyze the EXPANDed instead
# NOANL
# f take next f-ile (see /rcrsrc/../rcref.hlp)
# Y/y=yes,known (Y=reference with,y=silent)
#	Y not bltin(SL)		Shp 	NOt shp			 Own file

Chkfluid = ${TopDir}/chkfluid# Script that checks for undeclared fluids

.SUFFIXES: .o .sl .shp .sts

Init = steup.com

SedSrc = ../sedit.sl

# ../seterm.sts

SedObj = ../sedit.o

BasSrc = makefile stecup.sl dfdm.sl gctrap.sl \
	../autold.sts ../steup.sts ../steupv.sts \
	../basfun.sts ../basmac.sts ../basste.sts \
	../pdef0.sts ../pdefr.sts ../pdefrt.sts ../pdef.sts \
	../pdefw0.sts ../pdefwt.sts ../pdeft.sts \
	../pdsymn.sts ../pdefal.sts \
	../tsrsp0.sts ../sdef.sts ../sdefrn.sts \
	../tedef.sts ../tedefs.sts ../tedefx.sts ../teitym.sts ../teityp.sts \
	../qtcom0.sts ../qtcomp.sl ../qtcom2.sl
BasObj = ../basfun.o ../basmac.o ../basste.o \
	../pdef0.o ../pdefr.o ../pdefrt.o ../pdef.o ../pdocum.o \
	../qtcomp.o ../sdef.o ../sdefrn.o

#:up:REMOVABLE FILES are those *.sts in Bas-Src and Tsr-Src that *occur* in
#  dito ...Obj. (But *after* MAKE succeeded in creating correspoding .o-file!)

TsrSrc = ../order.sts ../tsrdf0.sts ../tsrdf1.sts \
	../tsrdfc.sts ../tsrsp.sts ../tsrspo.sts ../tsrsps.sts \
	../tsrsu0.sts ../tsrsu.sts ../gtdez.sts

# ../tsrac.sts ../tsrbk0.sts ../tsrtr.sts ../tsrsyz.sts

TsrObj = order.o tsrbk0.o tsrdf0.o tsrdfc.o tsrsp.o tsrspo.o tsrsu0.o tsrtr.o

#stensor.exe: shpmas.o ${BasObj} ${TsrObj} ${SedObj} 

all: stensor# test

stensor: ${StsRoot}

rtensor: ${RtsRoot}

cstensor: ${CStsRoot}

istensor: ${IStsRoot}

nstensor: ${NStsRoot}

${StsRoot}: ${Lisp} ${ShpRoot} ${StsIma} ${BasSrc} ${TsrSrc} ${SedSrc}
	echo "(LOAD STECUP)" | \
	${RunLisp} 200 204 ${Lisp} -I ${ShpIma} -D ${StsIma} -S 3M -X
#	${RunLisp} 200 204 ${Lisp} -I ${ClaIma} -D ${StsIma} -S 3M -X

${RtsRoot}: ${Lisp} ${RhpRoot} ${RtsIma} ${BasSrc} ${TsrSrc} ${SedSrc}
	echo "(LOAD STECUP)" | \
	${RunLisp} 200 204 ${Lisp} -I ${RhpIma} -D ${RtsIma} -S 3M -X

${CStsRoot}: ${Lisp} ${ShpRoot} ${CStsIma} ../steupv.sts ${StsSrc}# ${StsLog}
	echo "(LOAD STECUPI)" | \
	${RunLisp} 200 204 ${Lisp} -I ${ClaIma} -D ${CStsIma} -S 3M -X

#-rm ${ClaLog}/mkclassi.tmp

${IStsRoot}: ${Lisp} ${ShpRoot} ${IStsIma} ../steupv.sts ${StsSrc}# ${StsLog}
	echo "(LOAD STECUPI)" | \
	${RunLisp} 200 204 ${Lisp} -I ${ShpIma} -D ${IStsIma} -S 3M -X

${NStsRoot}: ${Lisp} ${ShpRoot} ${NStsIma} ../steupv.sts ${StsSrc}# ${StsLog}
	echo "(LOAD STECUP)" | \
	${RunLisp} 200 204 ${Lisp} -I ${ShpIma} -D ${NStsIma} -S 3M -X

# shpmas.o ${BasObj} ${TsrObj} ${SedObj}
#	${Sheep} ${ShpSw} < steup.sts
#	-mv ${TopDir}/stensor${EXE} ${TopDir}/stensor.bak
#	${Mv}  nstensor${EXE}  ${TopDir}/stensor${EXE}

#cstensor.exe: shpmas.o ${BasObj} ${TsrObj} ${SedObj} 
#	echo "(LOAD steup)" | ${Classi} ${ShpSw}
#	-mv ${TopDir}/stensor${EXE} ${TopDir}/stensor.bak
#	${Mv}  nstensor${EXE}  ${TopDir}/stensor${EXE}
#       @<fop>fixexe nstensor${EXE}

#stensor:   stensor.exe
#cstensor: cstensor.exe

Sheep  = ${ShpDir}/sheep#    Whichever you want to be included in STENSOR,
Classi = ${ShpDir}/classi#   by command (V)MAKE STENSOR or CSTENSOR,respectvely
ShpSw = -X

#    ****  End of normal command:   VMAKE STENSOR  ****
#${ClaDir}classi${EXE}: ${ShpFil} ${ClaObj} claup.shp ../claend.shp
#	echo "(LOAD CLAUP)" | ${Sheep} ${ShpSw}
#	${Mv} classi${EXE} ${ClaDir}classi${EXE}
#all: shpmac.o sheep.exe ${OtherObj}
#Shpcom = ${Slc} -l shpmac.o
# Doing:	UN MAKE STENSOR
# Shpcom removed gave at compilation:	unix " order.sts"	- not found.
# Being:	Shpcom = ${Slc} -l shpmac.o     and   #Slc = slc -s  removed,
# gave:		unix " -l shpmac.o order.sts"	-not found.

Slmacs =${SlLib}/slmacs.o
Slc1 =${SlspDir}/slc#                Patched compiler name
Slc =${Slc1} -${Quiet}sL ${Slmacs}# Patched compiler to use for compilation.
# SHPMAC shpmac.sl shfrnz.sl shpmcf.sl lglobl.sl tglobl.sl shpvrn.sl
#ShpMac =${ShpLib}/shpmac.o#	Sheep macro file
#Shpcom = ${Slc} -l ${ShpMac}#	Compiles Sheep files
#Shpcom = ${Slc} -l shpmac.o
#ShpMas =shpmas.o#    Sheep macro file, S-tensor version. I Gave FLAG undefined

MasSrc = shpmas.sts basmac.sts
ShpMas =${StsSrc}/shpmas.o#	S-tensor macro file
Stecom = ${Slc} -L ${ShpMas}# Compile S-tensor files with local shpmaS
#:upexpert  If you change BASMAC or SHPMAS (rarely), then delete all stensor o-
#:upexp    files,so recompilation of all others are forced using the new SHPMAS
shpmas.o: ${MasSrc}
	${Slc} shpmas.sts

.sts.o: shpmas.o
	${Stecom} $*.sts
.shp.o: shpmac.o
	${Shpcom} $*.shp
.sl.o: shpmac.o
	${Shpcom} $*.sl
lglobl.o: shpvrn.sl lglobl.sl
	${Shpcom} lglobl.sl

# Test STENSOR by running some TEst-files
test: stest testrg

stest:  ${StsLog}/stest.log

${StsLog}/stest.log: ${StsRoot} stest.def# ${StsLib}/cord.k
	-rm ${StsLog}/stest.tmp
	${RunLisp} "0" 4 ${Lisp} -I ${StsIma} >${StsLog}/stest.tmp < stest.def
	-rm ${StsLog}/stest.bak
	-mv ${StsLog}/stest.log ${StsLog}/stest.bak
	mv ${StsLog}/stest.tmp ${StsLog}/stest.log
	-rm ${StsLog}/stest.dif
	-diff ${StsLog}/stest.bak ${StsLog}/stest.log > ${StsLog}/stest.dif
	-rm ${StsLog}/output.dif
	diff ${StsLog}/output.ref ${StsLog}/output.tmp > ${StsLog}/output.dif
	rm ${StsLog}/output.tmp

cord:  ${StsLog}/cordr.tmp

${StsLog}/cordr.tmp: ${StsLib}/cord.def ${StsLib}/cordr.def	# ${StsRoot}
	-rm ${StsLog}/cordr.tmp
	${RunLisp} "0" 4 ${Lisp} -I ${StsIma} >${StsLog}/cordr.tmp\
					      <${StsLib}/cordr.def
	-rm ${StsLog}/cordr.bak
	-mv ${StsLog}/cordr.log ${StsLog}/cordr.bak
	mv ${StsLog}/cordr.tmp ${StsLog}/cordr.log
	-rm ${StsLog}/cordr.dif
	-diff ${StsLog}/cordr.bak ${StsLog}/cordr.log > ${StsLog}/cordr.dif
	-rm ${StsLog}/cord.dif
	diff ${StsLib}/cord.blf ${StsLog}/cord.blf > ${StsLog}/cord.dif
	rm ${StsLog}/cord.blf

# Test SHEEP by computing the Einstein tensor for the Godel metric.
godel: ${StsLog}shptst.log

${StsLog}shptst.log: shptst.shp# ${StsLog}/cord.blf
	-rm ${StsLog}/shptst.tmp
	${Lisp} -I ${ShpIma} > ${StsLog}/shptst.tmp < shptst.shp
	-rm ${StsLog}/shptst.bak
	-mv ${StsLog}/shptst.log ${StsLog}/shptst.bak
	mv ${StsLog}/shptst.tmp ${StsLog}/shptst.log
	-rm ${StsLog}/shptst.dif
	-diff ${StsLog}/shptst.bak ${StsLog}/shptst.log > ${StsLog}/shptst.dif
	-rm ${StsLog}/godel.dif
	diff ${ShpLog}/godel.lst ${StsLog}/godel.tmp > ${StsLog}/godel.dif
	rm ${StsLog}/godel.tmp


testrg: ${StsLog}/testrg.log

${StsLog}/testrg.log: ${StsRoot}  ${StsLib}/testrg.def
	-rm ${StsLog}/testrg.tmp
	${RunLisp} "0" 4 ${Lisp} -I ${StsIma} > ${StsLog}/testrg.tmp \
					      < ${StsLib}/testrg.def
	-rm ${StsLog}/testrg.bak
	-mv ${StsLog}/testrg.log ${StsLog}/testrg.bak
	mv ${StsLog}/testrg.tmp ${StsLog}/testrg.log
	-rm ${StsLog}/testrg.dif
	-diff ${StsLog}/testrg.bak ${StsLog}/testrg.log > ${StsLog}/testrg.dif
	-rm ${StsLog}/output.dif
	diff ${StsLog}/output.ref ${StsLog}/output.tmp > ${StsLog}/output.dif
	rm ${StsLog}/output.tmp


##### Cross reference listing
#icref: isheep.crf ishmac.crf cord.crf	vmake sheep
#The working system. vmake cref, un vmsmake cref
#stensor.crf: steupv.sts ${BasSrc} ${TsrSrc} ${Init}

cref: ${StsLog}/stensor.crf

${StsLog}/stensor.crf: ${BasSrc} ${TsrSrc}
	${ShpCref} -No ${StsLog}/stensor.tmp stecup.sl \
	 > ${StsLog}/stscrf.tmp

#	slisp -f loadcrf -E (docref) steupv.sts
#         shpmas ^+deactivate load    load files	../globs.sl
isheep.crf: isheep.sl ilam.sl tensor.sl ${ILamSrc} ${TenSrc} ${Init}
	slisp -f loadcrf -E (docref) isheep.sl
shpmas.crf: ${MacSrc}
	slisp -f shmccrf -E (docref) shpmas.sts
ishmac.crf: ${IMacSrc} ${TMacSrc}
	slisp -f shmccrf -E (docref) ishmac.sl
tensor.crf: tensor.sl ${TenSrc}
	slisp -f loadcrf -E (docref) tensor.sl
lam.crf: lam.sl ilam.sl ${LamSrc}
	slisp -f loadcrf -E (docref) lam.sl
ilam.crf: ilam.sl ${LamSrc}
	slisp -f loadcrf -E (docref) ilam.sl
.sl.crf:
	slisp -f shpcrf -E (docref) $*.sl
.sts.crf:
	slisp -f shpcrf -E (docref) $*.sts
