%:fil DOFOR.SL  	Substituting stepper: (DOFOR x (v1 v2..) do1 do2..)
%:f		Used:  -Independently,	  -for DOFORCH,  -and with IOMAKE.

% (DOFOR x (v1 v2..) do1 do2..) Performs do1,do2.. for x = v1,v2..
% Cfr MANUAL p 75

% Copyright (c) 1991 Lars Hornfeldt,	Phys. dep. Stockholm Univ.,	Sweden.

%:new VALUE-LIST to DOFOR
%	May hold 'TO' eg (DOFOR x (1 TO 7) (PRINT 'x))
%	May contain functions:    (2 TO (ADD1 y))
%	May be some symbol. Then its value is expected to be the argument list.

(FLUID '(DO!* FN!* L!* VAR!*))

(OR(GETD 'MKSEQ)		% Also in pdsymn
   (DE MKSEQ (M N) (CNDR (SEQ0L (PLUS2 M N)) M)) )%:bM=Offset,N=leNgthOfSequnce

(OR(GETD 'MAYEVAL)
(DE MAYEVAL (NZA!*) (COND		%:b May evaluate this expression?
  ((ATOM NZA!*)		%:Frz-BOUNDP on Numbers is illegal
%:FIX V	(AND (IDP NZA!*) (BOUNDP NZA!*) (NOT (GETD NZA!*)))
	(AND (IDP NZA!*) (BOUNDP NZA!*) (NOT (GETD NZA!*)) NZA!*) )%NoPluginNil
  (T	(GETD (CAR NZA!*))) ))		%:psl drop above not-getd?
)
(OR(GETD 'QEVAL)
(DE QEVAL (L!*) (COND ((MAYEVAL L!*) (EVAL L!*)) (T L!*)))    %:b Quareful Eval
)
(DE FNEVAL (L!*) (COND		%:b Eval if arg=(Fn ..) else return arg
  ((AND(PAIRP L!*) (GETD(CAR L!*))) (EVAL L!*))
  (T L!*) ))

(OR(GETD 'RPLACAQEVAL)
(DE RPLACAQEVAL (L!*) (RPLACA L!* (QEVAL (CAR L!*))))	%:b
)
% FIX V: QEVAL-plugin of value doubtful in (DOFORCH z (u v) 'z)	%:TMP Switch?
% plugs in v-val="Not_In_See"! Tmpfix: MAYEVAL dont plugin NIL-value,and V=Nil:
(DE DOFORF (FN!* L!*) (PROG (X!* VAR!* DO!*)	%:s for DOFOR(CH)
  (SETQ VAR!* (POPL!*))			% Variable name
  (SETQ DO!* (CONSIFCDR 'PROGN (CDR L!*)))	% Rest of args should be run
  (COND
   ((IDP (SETQ L!* (CAR L!*)))		% Symbol:
	(PRINB L!*)
	(SETQ L!* (EVAL L!*)) ))	% value=arglist
  (AND	(SETQ L!* (MAPCAR L!* 'FNEVAL))		% List of values for VAR
	%(RPLACAQEVAL L!*)			% Always fix eg (ADD1 X)
	(NOT (MAXONE (CDR L!*)))		% If L!* has at least 3 elmnts:
	(EQ (CADR L!*) 'TO)			% -of which 2:nd is "TO"
	(RPLACAQEVAL (CDDR L!*))		% -then eval 3:rd (ADD1 y), and
	(SETQ L!* (NCONC
	 (MKSEQ (CAR L!*) (ADD1 (DIFFERENCE (CADDR L!*) (CAR L!*))))
	 (CDDDR L!*) )) )			% Remaining values?
  (COND ((AND (GETD (CARDOWN L!*))		% If Ftn,
	      (NOT (TENP (CARDOWN L!*))) )	% that is not a tensor,
		(SETQ L!* (EVAL L!*)) ))	% then evaluate.
L (OR L!* (RETURN NIL))
  (EVAL (LIST 'PROG '(FN!* L!* VAR!* DO!*)	% Eval(protected) what to do,
   (EVALCONS FN!* '((FNEVAL (CAR L!*)) VAR!* DO!*)) ))	% -after setting it up
  (SETQ L!* (CDR L!*))
  (GO L) ))

(DF DOFOR (L!*) (DOFORF 'SUBST L!*))		%:h DOFORCH uses SUBSTCH

% (MACRO DOFORCH L* (AUTL fil))
(AND (EQCAR (FCAR (FCDR (FCDDR (GETD 'DOFORCH)))) 'AUTL)
     (REMD 'DOFORCH)
     (AUTOLD DOFORCH DOFORCH) )

% DOFOR.SL end
