%:fil QTCFAC.SL 	FACTORIZATION done by TCOMP (experimental)	%:hlp
% Automatic factoring is good, since algs may be huge results of processing

% If k,c are shp-numbers (dont change order of terms), then
% factor out k in	k (T + T + T) + c (T + T + T)  from single tensors

% (For tensor-products, its supposed(?) better to mult it on one of factors)
% Non-numeric koefficients will change the canonical order of terms when
% multiplied onto the terms, so those must be multiplied on early.

% A Facsum is put as an ALG-object into the &L and recursively hit with MKBL1.
% That &alg should only record as dmys those that are dmy INSIDE the &alg,
% so for factors that are i-CONTRACTED to the remaining sum, i=free inside:
% Ti (Ai + Bi)	   turn to	(alg . i (1   ((alg i . (..A) (..B)))	Ti))
%				    sumi		&=A+B		Ti

% Also factor dummy-separated objects eg	1/2  (Ai + Bi) <T j j>
% ie isolate maximally dmy-containing objects to a &alg, sum it separately.
% Result is	1/2 ((&1=Ai+Bi) (&2=Tjj))   -no TSRL, only operations in &L
% Tsr with INTERNAL dmy always gets own &alg:	Tiji Aj = sumj Aj (sumi T)
% Tjj A + A B + Tjj B		Prior factoring of T with internal dmy
% Tjj (A + B)     + A B	since that summing is heaviest operation
% Last, facnum innermost, to	Tjj (1/2(A + B))  + A B
% T A + 1/2 A + 1/2 B	  not to     1/2(A + B) +T A, but A(T+1/2) + 1/2B?
% Tjji Rikk  into:	sumi  (sumjT) (sumkR)
% Tjj Rkk + Tjj Sii + Rkk Sii	 only factors first:	Tjj(R+S) + R S
%			thus you should save Rii and Sii as new objects
% Macros required to run bulfs made with MCOMP true:
(SETQ MACRO!* (IFP CULISP!* 'MMACRO 'MACRO))	%:b Name of 'MACRO'-property
(DE MCROP (FN) (AND FN (EQCARE FN MACRO!*)))
(DE MXPND (X) (COND
  ((MCROP (GETD (CAR X))) (INCR TERM!#) (MACEXPD X))
  (T	(NCONS X)) ))

(DM PROGANS (L) (PROG (TERM!#)
  (SETQ TERM!# 0)
  (RETURN
   (APPEND '(PROG (ANS!*) (SETQ ANS!* 0))
	    (APPEND (MAPCAN (CDR L) 'MXPND) '((RETURN ANS!*))) ) ) ))

(FLUID '(AL1 NBR SUM0 SUM FACTORTYPES))

% &IAPly for Alg. Used by RCIX
(DE !&IAPA (ALG)
 (CONSCAR ALG
  (CONS (FUNCALL !&IAPF (CADR ALG))
   (CONSCAR (CDDR ALG) (CDDDR ALG)) )))

(PUT 'ALG '!&IAPL '!&IAPA)

% FaCtorNUmber? -Predicate:  &L=nil,	Max one tensor, 	Koe=nr
(DE FCNUP (AL1) (AND (NOT (CADR AL1)) (MAXONE (CDDR AL1)) (SNUMPR (CAR AL1)) ))

% MaKe a TerM that has a &L that contains (alg ... SU)		???LOCAL
(DE MK!&TM (N FX SU TL)
% (PROGN (SETQ !*CINX CIX) ..)
%	(MAPC FX (LAMBDAX (SETQ !*CINX (DELETE X !*CINX))))
  (CONS N (CONS   (NCONS (RCIXS SU))  TL)) )

(DE FCWSH (F1 F2 N FX TL) (COND
  ((SETQ F1 (!*WASH F1 (CDR SUM)))		% *WSHL contain remaining terms
		(MAPC (SETQ F1 (CONS AL1 F1)) F2) % While those fit goes to f1
		(MK!&TM N FX F1 TL) ) ))	% and further into &L as subalg

% Turn		k (T + R + S)	into	(k ((alg .. T R S)))
% Find terms in SUM related (by having same num koe) to one of terms, AL1:
(DE FCNUM (AL1) (PROG (NBR)
   (AND	(SETQ NBR (FCNUP AL1))	% Trm AL1 was Nr times Tsr?	(-And of course
	(NOT (ONEP NBR))	% nr not =1)	Then srch SUM for trm:
	(RETURN (FCWSH	(LAMBDAX (EQUAL NBR (FCNUP X)))	% with same Nbr
			(LAMBDAX (RPLACA X 1))	% Chnge Nbr in &alg to 1 and N
			NBR FIX NIL)) ) )) %only on top. No TSRL.=(Nbr (1T+1R))

% Cons If L = non-nil		(DE CONSIFL (X L) (AND L (CONS X L)))
(DE FCTE1 (TSR) (FCWSH		% See if single TSR exists elsewhere in SUM
  (LAMBDAX (MEMBER TSR (CDDR X)))	% Trms with TSR
  (LAMBDAX (RPLACD X (DELETE TSR (CDR X))))	% Remove TSR in each term
  1 (CDR TSR) (NCONS TSR)  ))		% Reslting trm= (1 &alg TSR)
%    ^^^ ix, if dmy, NOT to be ran in deeper ctrctions! (Already setup run)

(DE FCTEL (L) (AND L (OR  (FCTE1 (CAR L))  (FCTEL (CDR L)) )))
% Factor out TENsor. Get 1:st tsr in AL1 that has multi-term occurence
(DE FCTEN (AL1) (FCTEL (CDDR AL1)))

% Run a specific kind of factorization. Each Fn creates its own term V which
(DE FCTRF (FN) (PROG (SUM V)	% contain a &L /w 1 elmnt = new long alg
  (SETQ SUM SUM0)		% Through pointer change SUM0 destructively
L (AND (SETQ V (FUNCALL FN (CAR SUM))) %Run fctrzefn on trm,V=trm /w long alg
	(RPLAD SUM V (REVERSIP !*WSHL)) ) % + remains, not sucked into &ofV
  (AND  (SETQ SUM (CDR SUM))	(CDR SUM)  (GO L))  ))

(SETQ FACTORTYPES '(FCTEN FCNUM))
% FaCtor out common TENsors and NUMbers
(DE FCTOR (SUM0) (PROGN (MAPC FACTORTYPES 'FCTRF) SUM0))

%:hlp (LTCOMP [T/NIL]) set up TCOMP for coming LISP-compilation of BLF/or not.
%:h   (LTCOMP) show mode, arg T for L-compilation, arg NIL for interpretation.
%: Simply sets all switches/loads files, as of Chapter 7.10 and 7.11 in manual.
%: Initial state is as of (LTCOMP NIL).

(DF LTCOMP (X) (COND
  ((NOT X)	LCOMP)
  ((CAR X)	(SETQ LCOMP
		 (SETQ MCOMP (SETQ MACROEXPAND (CAR X))) ) % If arg was non-nil
		(LOAD SUMBOP)	)			% -then load
  (T	(WARNINGL
364 "Turning back off is yet refused. Contractions would go wrong."	%:war
	)) ))
%:w	(LTCOMP nil) is not yet recommended; Will normally cause problems.
%:w	Instead restart a fresh Stensor, and first TCOMPOUT a file in
%:w	the initial setting, which correspond to (LTCOMP nil).
%:w	  Then do (LTCOMP T) and TCOMPOUT to another file those objects you
%:w	want in that more efficient form. In subsequent sessions, load these
%:w	two. Or tcompout all objects, in both modes and load these inter-
%:w	changably as desired. REAL need to jump between the two modes
%:w	interactively is inprobable, but then email me.#
%:w

% QTCFAC.SL end
