% File:SETERM.SL	SheepEditor TERMinal driver, used by eg SEDIT
% 1:st some hlproutines:
(DE TYOL (L) (MAPC L 'TYO))
(DE PRINCL (L) (MAPC L 'PRINC))
(DE ESC NIL (TYO 27))

% ***TERMINAL-DEPENDENT part, start***  This version is for ANSI terminals,
% change for others. To see what functions do, se eg Ambass-manual, since the
% functions mainly have the same EFFECTS and NAMES as in the ANSI-standard.
(DE CSI NIL (PROG2 (TYO 27) (TYO 91)))
(DE IND NIL (PROG2 (ESC) (PRINC 'D)))
(DE RI  NIL (PROG2 (ESC) (PRINC 'M)))
(DE CSINX   (N X)  (PROG2	(CSI) (PRIN1 N) (PRINC X)))
%No Zero: used when (CSINX 0 x) shouldnt print anything:
(DE CSINXNZ (N X)  (COND ((ZEROP N))	(T	(CSI) (PRIN1 N) (PRINC X))))
(DE CUU (N) (CSINXNZ N 'A))	% Rare use
(DE CUD (N) (RPT '(IND) N))% Rare use. To scroll, (CSI)NB wont work at bottom
(DE CUF1 NIL (PROG2 (CSI) (PRINC 'C))) % Rare use
(DE CUF (N) (CSINXNZ N 'C))
(FLUID '(CUFLENGTH BLANK))	(QSET 'BLANK '! )	% Quareful set
(SETQ CUFLENGTH 4)	% To tell when blanks are faster (in eg SHOWORLD)

(DE CUB1 NIL (TYO 8))		% ^H is faster than (CSI)D
%(DE CUB1 NIL (PROG2 (CSI) (PRINC 'D)))
(DE CUB (N) (CSINXNZ N 'D))	% Rare use

%(DE ZSC NIL (ESC) (PRINC 7))% Save   Cursor pos. % Rare use Avoid:Ambspecific
%(DE ZRC NIL (ESC) (PRINC 8))%Restore Cursor pos. % Rare use Avoid:Ambspecific

% ***PART TWO, ON RENDITIONS::***
%   SGR=Set Graphic Rendition:	
(DE SGR (L) (PROG2 (CSI) (PRINCL L) (PRINC 'm)))
% *** May chnge those below to set other renditions on other terminals: ***
% 1:st should set to the NORMALly used rendition-mode for the terminal:
% 2 and 3 should give OTHER renditions than NORMAL, eg as here INT/LIN

(SETQ RENDNORMAL '(7))	% "Normal" for Ambass=revrse
(SETQ RENDBOLD (CONS 1 (CDR	% INTense+REVerse
(SETQ RENDULINE	(CONS 4 (CONS '!; RENDNORMAL))) ))) % underLINe+REVerse
(SETQ RENDREVERSE NIL)		%   $  [  4  ;	 7  m
(FLUID '(RENDNORMAL RENDBOLD RENDULINE RENDREVERSE))
(DE SGRNORMAL NIL (SGR RENDNORMAL))	% "Normal" for Ambass=revrse
(DE SGRBOLD   NIL (SGR RENDBOLD))	% INTense+REVerse
(DE SGRULINE  NIL (SGR RENDULINE))	% underLINe+REVerse
(SETQ BR!-EXIT  '((PROG2 (SGR RENDREVERSE) '"eXit ")
		  (GTPRP 'BR!-OWNER)	(ASCII 32)	(GTPRP 'BRLVL)
		  (PROG2 (SGRNORMAL) (ASCII 32)) ))
(DE ZCGR () (PROG2 (TYO 27) (TYO 57)))% Change Graphic Rendition=rewrite=<esc>9
(SETQ RENDA RENDNORMAL)	% Should be the basic, most used. (Amb=reverse)
(SETQ RENDB RENDULINE)	% The others are of INCREASING stand-out, ie
(SETQ RENDC RENDBOLD)	% for Amb B=underline rev, C=intense rev.

%(DE L*CSI NIL (TYOL '(126 91 91)))
%(DE L*CUB (N) (PROG2 (L*CSI) (PRIN1 N) (TYO 68)))
% *** End of terminal-dependent part ***

% ***	Now some top-functions:
(DE SGR!-DO!-SGR (R1 DO R2) (PROG2 (SGR R1) (EVAL DO) (SGR R2) (ZCGR)))
	(SETQ O!*MSG !*MSG) (SETQ !*MSG NIL)

(FLUID '(UPGRIND UPROMP REND!-TOP REND!-FOIN C!% D!%))

%Typ OUT something under temporarily other rendition REND:
(DM REND!-DO (L) (CONS 'PROG2
  (CONS (LIST 'SGR (CADR L)) (APPEND (CDDR L) '((SGRNORMAL)) )) ))

%(DE OUTREND (REND L) (PROGN (SGR REND) (MAPC L 'PRINE) (SGRNORMAL)))
%(DE OUTBOLD (L) (OUTREND RENDBOLD L))
%(DE OUTREVERSE (L) (OUTREND RENDREVERSE L))

(DE RENDPRINE (REND L) (REND!-DO REND (MAPC L 'PRINE)))
(DE RENDPRINC (REND X) (REND!-DO REND (PRINC X)))
(DE BOLDPRINE (L)  (RENDPRINE RENDBOLD L))
%(DE REVPRINE (L) (RENDPRINE RENDREVERSE L))
(DE REVPRINC (X) (RENDPRINC RENDREVERSE X))

(DE DOWNUP () (PROG2 (IND) (RI)))

(SETQ UPGRIND (SETQ UPROMP T))
(VAXDEC (SETQ UPGRIND (SETQ UPROMP NIL)) NIL)

(DE PROMP (X) (PROG (!*DDTIN)
  (AND UPROMP (RI))	%This (RI) only on VAX! not %+DEC10
  (PRIN2 X) (DOWNUP) (SGRULINE) (SETQ X (READ)) (SGRNORMAL) (RETURN X)))

(SETQ INITFN!* '(LAMBDA NIL (PROGN (SGRNORMAL) (INITRS))))
%+DEC10 (DE UPTAB () (PROGN (RI) (TYO 9) NIL)) % One up = good on dec
	(DE UPTAB () (PROGN (RI) (TYO 9) NIL))  % Not on VAX?

(SETQ REND!-TOP RENDC)
(DE TOPLEVEL () (PROG NIL
 L	(SETQ C!% (SGR!-DO!-SGR REND!-TOP '(READ) RENDA))
	(TERPRI)
	(COND ((NOT (ATOM (SETQ D!% (ERRORSET C!% T !*BAKGAG))))
				(PRINT (SETQ D!% (CAR D!%)))))
	(GO L)))

(OR (GETD '!%FOIN)	% This has been loaded before -quit
    (AND (GETD 'FOIN)	% Am in SHEEP - then:
	 (VAXDEC (MOVD '!%FOIN 'FOIN)
		 (PUTD '!%FOIN 'EXPR (CDR (GETD 'FOIN))) )
	 (DE FOIN () (COND
	   ((AND (NOT NOMSG)
		 REND!-FOIN) (SGR!-DO!-SGR REND!-FOIN '(!%FOIN) RENDA))
	    ( T		(!%FOIN))))	% Redefine FOIN to use
	 (SETQ REND!-FOIN RENDC)))	% REND-FOIN as rendition

% Other terminals, changeover:
(DE RI52 () (PROGN (ESC) (PRINC 'A)))	% Cursor UP for VT52 (Reverse Index)
(DE RI5 (N) (RPT N '(RI52)))
(DE VT52 () (PROGN (CSI) (PRINC "?2l") (SETQ RENDNORMAL '(0)) ))
(DE ANSI () (PROGN (ESC) (PRINC "<")   (SETQ RENDNORMAL '(0)) ))
(DE AMBASS () (SETQ RENDNORMAL '(7)))

(SETQ !*MSG O!*MSG)
% SETERM.STS end
