%:fil SHPSUB.SL 	(SETSUBFOR sulis X) -set multiple Sheep-subst%:hlp

(LOAD DOFORCH)

%:hlp (SETSUBFOR sulis X A B...) -is like repeating SETSUB, for X being A,B..
% ex: (SETSUBFOR ESUL X A B C D)  SIN(X)^2 $  SINX2 $
% -sets up substitutions for:     SIN(A)^2 to SINA2, SIN(B)^2 to SINB2 etc
% -where A,B.. can be omitted if (VARS A B..) has been done, ie then those
% variables that have obtained NAMES will be used (if SETSUBNUM is on, ALL).

(NEWSWITCHES (
SETSUBNUM	"SETSUBFOR sets up also for 'numeric' variables")) %:nsw

% Sulis and X can not be omitted.

% In this case, the replacement SINX2 being a symbol, also a differentiation
% property is set up for the symbol by trying to differentiate the template
% SIN(X)^2 wrt all variables.

% Note that the X is replaced also INSIDE a symbol. This happens inside all
% symbols. (that not appear in "car"-positions, ie as first elements in lists).
% Thus inside the symbols SINX2 AND COSX2 below, the X char is substituted for:
% ex: (SETSUBFOR ESUL X A B C D) TAN(X)^2 $  SINX2/COSX2 $
% -sets up substitutions for:    TAN(A)^2 to SINA2/COSA2, TAN(B)^2 to SINB2/..

(DF SETSUBFOR (L) (PROG (S)
  (EVALIST 'SETSUB (CAR L))	% Read formulas
  (RPLACD				% replace
   (SETQ S (LAST2PAIR (EVAL (CAR L))))	% that last substitution, with
   (PROGN
    (SETQ S (CADR S))	% Last S-ubst-pair, to be changed
    (MAPCAR
     (OR(CDDR L)		% -Set subs for each variable,or symbolic vars
	(AND SETSUBNUM (VARS))	% Should setsub also for NUM-var? GO!
	(MAPCAN(VARS) (LAMBDAX(AND(IDP X) (NCONS X))))%:b? NCONSIDORF
	(ERRORL
755 "No (VARS..)nams given prior to (SETSUBFOR sul x).Do (ON SETSUBNUM)?" %:err
) )
%:e	You did: (SETSUBFOR sul x) which should be used to duplicate
%:e	your single mask > replacement-pair, for x = each of the variable
%:e	names, as specified with eg (VARS t r fi theta). However, no VARS
%:e	has been done! Then instead say (SETSUBFOR sul x sbl1 sbl2..) to
%:e	tell which symbols the mask/replacement should be duplicated for.
%:e		Also cfr file shpsub.sl for info.#
%:e

     (LAMBDAX (PROGN
	(SETQ X (CONS (SUBSTCH X (CADR L) (CAR S))	% Make X = New subspair
		      (SUBSTCH X (CADR L) (CDR S)) ))
	(AND (ATOM (CDR X))	% Constructed new symbol.	Diff:
	     (ERRSET		% Quit in batch etc, if diff- FUNS info needed.
		(QPUT (CDR X) CRDIF!*		% Give new symbol a diff-prop
		      (MAPCAR (VARMLIS CRDIF!*) % for each variable, computed
			(FUNCTION(LAMBDA(N) (SDIFF (CAR X) N))) ) ) % from orig
		NIL)	)
	X)) )  ) ) ))
%:h
%:hlp (INVSUBS sulis t1 t2..) invert substitutions sulis on tensors t1,t2,...
%:h Does LSIMP on t1,t2... with a temporary ESUL made by inverting sulis.
%:h The argument 'sulis' should be either:
%:h			1: -a list itself explicitely, or
%:h			2: -a symbol which has a list as value.
%:h	The list eventually pointed at, may in both cases be, or not be,
%:h	a proper substitution list, ie have or not have 'SUBS' as header.
%:h	Substitutions are used INVERSED on the t1,t2,...

(DF ESULON (ESUL) (EVALCONS 'LSIMP
 (PROG1 (CDR ESUL) (SETQ ESUL (CAR ESUL)))))

(DE DOESUL (DO ESUL) (EVAL DO))
(DF INVSULDO (L!*) (DOESUL		%:h eg (INVSULDO suli (MAKE tsr..))
  (CONS 'PROGN (CDR L!*))		% DO each of the commands,
  (CONS 'SUBS (MAPCAR			% -with this ESUL-list:
    (CDRIF (SETQ L!* (OR (AND (ATOM(SETQ L!*(CAR L!*))) (EVAL L!*))
			 L!*))
	   (AND L!* (EQCARE L!* 'SUBS)))
    'SWAP2))
	))
% SHPSUB.SL end
