%:fil TI.SL     	TI  -FLEXIBLE TIMING UTILITY			%:hlp
%:hlp		(TI cmd) -execute cmd(s),print cputime taken,return cmd-value.
% Example:	(TI (MAKE RIE))
% With output:	(NetTime 1h23m45s678ms GC:59s)
% -means the time (excluding time spent in GC) was 1hour 23 min 45sec 678ms
% -and the GC (Garbage Collection)-time was 59seconds
% TIMSG	    -is an optional string that TI prints out (use to identify timing)
% A large amount of switches and symbols are available for tailoring;see below.

(IFP (EQ 'PSL (SYSTYPE 'LISPSYSTEM)) (DE GCTIME () GCTIME!*))
(IFP (EQ 'CULISP (SYSTYPE 'LISPSYSTEM))
     (OR (GETD 'LMFAC) (LOAD DFDM)) )

(OR (GETD 'RPLACO) (LOAD BASFUN))

(OR (EQ 'ORION (SYSTYPE 'MACHINE))	% Except on orion (running in gnuemacs)
    (QSET 'TIBELL 30000) ) % If set, times > TIBELL (ms) rings a bell when done

(QSET 'TITOTAL T)
(QSET 'TIARG!* "**")	% Enhance-mark of cmdarg (to search/grep for).
(FLUID '(TIBELL TIMSG	% TIMSG is as TIARG,but specifies overriding string
	 TIARG!* TI!.G TI!.T TI!.A))

(COND
 ((AND (GETD 'NEWSWITCHES) (NOT (MEMQ 'NOHMS SWITCHES)))
     (NEWSWITCHES
	(NOHMS "Depress HourMinSec-conversion of time")
	(EXPERT "Decrease verbosity in help,TI etc")
	(TITRUNC "Truncate the ms info. Depress ti-msgs < 1s")
		%"Ignore timing if less than 1s. Truncate to s"
	(TIARG "Include timed cmd_arg in printed timing info,+TIARG*")
	(TITOTAL "Also show total time") ))
 (T (FLUID '(NOHMS TITRUNC TIARG TITOTAL))) )

(REMD 'TI)
(DF TI (TI!.C)			%:h TI-me Command(s): (TI cmd cmd2 ...)
 (PROG (TI!.G TI!.T TI!.A)	% Vars mustnt be changed by <Cmd>-evaluation!
%   (SETQ SPEAK (SPEAK))	% None in Slisp/Franz
    (SETQ TI!.G (GCTIME))
    (SETQ TI!.T (TIME))
    (SETQ TI!.A (EVAL (MKPROGN TI!.C)))		% store A-nswer
    (SETQ TI!.T (DIFFERENCE (TIME) TI!.T))	% IMMEDIATELY do timing,store
    (SETQ TI!.G (DIFFERENCE (GCTIME) TI!.G))	% IMMEDIATELY do timing,store
    (IFP (NOT (EQ 'CULISP (SYSTYPE 'LISPSYSTEM))) % On culisp, TIME already net
	 (SETQ TI!.T (DIFFERENCE TI!.T TI!.G)))	% -else make it net-time
    (COND
     ((NOT(AND TITRUNC (LESSP TI!.T 1000)))	% If not truncable,then:
      (PRIN2 (IFCONS		% Cons only if TIMSG nonnil, else returns List
       (OR TIMSG (AND TIARG (IFCONS TIARG!* (CAR TI!.C))))
       (NCONC
	(AND (OR TITOTAL (ZEROP TI!.G))		% Give total (alone,maybe)
	     (ESTSMSG				% produce list below:
106 %:msg (CONS 'LIST (NCONC	(IFPE EXPERT () '("Time:"))
 %:msg  			'((HMS (PLUS2 TI!.T TI!.G))) ))
	 ) )	  % (LIST "Time:" (HMS (PLUS2 TI!.T TI!.G)))	% CONCATID err
	(AND (NOT (ZEROP TI!.G))
	     (ESTSMSG			% present GC-time (list below):
107 %:msg (IFPE EXPERT '(LIST		   (HMS TI!.T)	   (HMS TI!.G))
 %:msg  		'(LIST "Net-time:" (HMS TI!.T)"GC:"(HMS TI!.G)))
		) ) ) ))
			% (DIFFERENCE (DIFFERENCE (SPEAK) SPEAK) 22)
			% Some CONSes=overhead
      (OR (ZEROP TI!.G) (QTRPRI)) ))		% Terpri unless short output
    (RETURN TI!.A)  ))

(DE HMS (N) (PROGN
  (AND TIBELL (LESSP TIBELL N) (PRINC ""))	%? (BELL)
  (SETQ N (DIVIDE N 1000))
  (OR (AND NOHMS N)			% Depress HourMinSec-conversion of time
      (DIV60 (CAR N)
	     (IFP FLOPPY!* ""
		(COND (TITRUNC "") (T (CONCATID (CDR N) '!m!s))) )
	     '(!s !m !h) ) )  ))%:psl -inhibit upcasing? Strings musnt CONCATID

% Divide X by 60,pushing result on TimeList, grabbing units from UN-list:
(DE DIV60 (X TL UN) (COND
  ((ZEROP X)	TL)
  ((OR (GREATERP 60 X) (NOT(CDR UN)))		% Small nbr, or no units:
		(CONCATID X (CAR UN) TL))	% Last timeunit. Done.
  (T	(DIV60	(CAR (SETQ X (DIVIDE X 60)))
		(CONCATID (CDR X) (CAR UN) TL)
		(CDR UN) ) ) ))

(AND (MEMQ (SYSTYPE 'MACHINE) '(ATARI AMIGA))	%:ATari timeresolution 1 sec
     (SETQ TITRUNC T) )
% TI.SL end
