%:fil TSRSPR.SL 	SP-applic: Subst Programs for Reverse diffoperators

%:hlp <REV> <A><B><C>...  REV is a special object that reverse factors to right,
% = ...<C><B><A>	  (regardless if they nevercommute) and removes itself.

(DE REVRTNL () (RPLACD !*RTNL (REVERSIP (CDDR !*RTNL))))	%:sp

(HNGIS (GET 'REV 'TSUL)		% Hang/Initiate on RghtParen an SP
	'(REV)
	'(REVRTNL) )

(PUSHV LASTN NIL)	(NEVERCOMMUTE REV)	% Protect global LASTN
(POPV LASTN)		% Restore val of global LASTN
(DPUT REV PRT PRTEN)	(DPUT REV CMPLX REV)

% (RDIFFOPERATOR Rop1 Rop2..) Reverse DIFFOPERATOR, differentiates from Right,
% and declared ANTICOMMUTING.
% Differs from ordinary DIFFOPERATORs results only by signs, and only when
% used on Anticommutative objects, since spreading from right.

% An ordinary diffoperator Op gives:
%  Op A B = (Op A) B + a A Op B		where a=+-1 depend on if A Anticommute

% While a from-right diffoperator Rop gives:
% Rop A B = A Op B + b (Op A) B		ie with sign b instead, since:

% Rop A B = Rev Op Rev A B = Rev Op B A = Rev (Op B) A + b Rev B Op A

% Ie 'Rop = Rev Op Rev'
% Below we use TWO kind of REV objects to enforce proper sequencing in time.
% This is since substitutions are normally searched FROM THE LEFT,
% which would have caused the LEFTMOST REV doing its work first!

(ON AUTONEVERCOMMUTE)	(ANTICOMMUTE A B OP ROP)
(DIFFOPERATOR OP)
(DIFFOP ROP)		% Reverse OPerator defined from the OPerator by:
(PDEF ROP)	<REV2> <OP> <REV1>$	% REV1 is to do its reverse before REV2

(NEWISUL 0 REV1)	(PUT 'REV1 'REV1 (GET 'REV 'TSUL))	% (Technical-
(NEWISUL 0 REV2)	(PUT 'REV2 'REV2 (GET 'REV 'TSUL))	%  ini of REVi)
(SETTSUP REV1 TSUL REV2)	% Crucial command which states the time order:
%	The substitutionlist REV1 should be used first (doing REV1-object),
%	then the standard list TSUL (spreading etc),
%	last the REV2 substitution list (doing REV2-object).

(PDEF RAB)	<ROP>  <A> <B>$
(PDEF OAB)	 <OP>  <A> <B>$
(PDEF ZE)	<RAB> + <OAB>$		% Test if zero

(SETNSUB TSUL)	<OP><A>$ <OA>$		% At moment, no {OP A} may remain, ie
		<OP><B>$ <OB>$$		% must rid of such,specify all results.
(ADDO (EEDEF ZE) 0)
% TSRSPR.SL end
