%:fil TSRTR.SL  	TR-ig simplification. Calling TSR-SUmsubs	%:hlp
%:h Commands:	 (TRIG TSR)	TSR must be a SYMBOL, which is a tensor
%:h		(WTRIG TSR)	or a symbol with a value.
%:h		(WTRIGLOOP)	For demo. Loads file tsrtrD which also
%:h				sets symbols XS, XC...
%		TRIGSUM		Name in the MACSYMA version; on arb expr
%		TRIGSE		One Arg = Sheep-Expression.
% Copyright (c) 1992 Lars Hornfeldt,	Phys. dep. Stockholm Univ.,	Sweden.

(IFP (AND CULISP!* FLOPPY!* (GETD 'CAR!-NIL!-LEGAL))
     (CAR!-NIL!-LEGAL T))

(PUSHV !*MACROEXPAND NIL)
%(COMPILETIME (LOAD SHPMAS))
(OR (GETD 'SUMS1) (LOAD TSRSU0))

(QSET  'TRIGHARDRPT 5)		% Maximal number of repeated TRIG-runs

(FLUID '(SPECF !*RTNL RL !*SPTR TSUBS WSUBS NOREN NCSMP NFSMP THENELSE
	SUMSG SSUBS TEN FCTR HYP!* COSSEEN SINCOS SINCOH
	TRIGHARD TRIGHARDRPT TRIGN TRIGB TRIG0 TRIGSUMEXPAND SINCOSKEEP))

(NEWSWITCHES (
TRIGHARD "Repeat SUMSUBS after success,but max TRIGHARDRPT times" ) (%:nsw
TRIGN	"TRIG -cmd includes N-ormal,forward search"	) (%:nsw
TRIGB	"TRIG -cmd includes B-ackward search"	) (%:nsw
SINCOSKEEP "(W)TRIG keeps obj SINCOS in result"	) (%:nsw
SECCSC	"Output cos(sin)^-n as sec(csc)^n"	)) %:nsw

%	"Output 1/cos as sec,1/sin as csc"
(PON TRIGHARD TRIGN TRIGB SECCSC)	%:MAC$
(AND (GETD 'ORDLX) (ORDLX SWITCHES))	% For DWIM

%:+MACDONE

% EFUN:Differentiation rules on such trigfunctions not setup by ddiff.shp
%	Most important as flag to allow FOIN input of csc(x),tanh(x)
%		that are created by (W)TRIG if SECCSC on.
%	Actual ftn under EFUN read just at diff, ie seldom, not cpu-intense,
%		so these less common trigs can have UNcompiled EFUNs;
%		advantage is: then codesharing possible:

(OR (BOUNDP 'LISTX!*) (SETQ LISTX!* '(X)))
% Shared pieces of interpreted programcode below,	are used to create:
(SETQ !*WSHP '((MKSEXPT X 2)))				% Power ((^ X 2))
(SETQ !*WSH1 (NCONS (CONSA 'MKTIMS -1 !*WSHP))) 	% ((* -1 (^ X 2)))
(SETQ !*WSHL (NCONS (CONS 'CADR LISTX!*)))		% ((CDR X))
(PUT 'TANH 'EFUN (LIST 'LAMBDA LISTX!*(CONSA 'MKPLUS 1 !*WSH1)))% 1-tanh^2
(PUT 'COTH 'EFUN (GET 'TANH 'EFUN))		% Same,here means 1-coth^2
(PUT 'SEC  'EFUN (LIST 'LAMBDA LISTX!* (CONSA 'MKTIMS
	(CONSA 'LIST ''SIN !*WSHL)	% (LIST 'SIN (CADR X))=(sin v)
	!*WSHP)))						% sec^2
(PUT 'SECH 'EFUN (LIST 'LAMBDA LISTX!* (CONSA 'MKTIMS
	(CONSA 'LIST ''SINH !*WSHL)	% (LIST 'SINH(CADR X))=(sinh v)
	!*WSH1)))						%-sech^2
(PUT 'CSC  'EFUN (LIST 'LAMBDA LISTX!* (CONSA 'MKTIMS
	(CONSA 'LIST ''COS !*WSHL)	% (LIST 'COS (CADR X))=(cos v)
	!*WSH1)))						% -csc^2
(PUT 'CSCH 'EFUN (LIST 'LAMBDA LISTX!* (CONSA 'MKTIMS
	(CONSA 'LIST ''COSH !*WSHL)	% (LIST 'COSH(CADR X))=(cosh v)
	!*WSH1)))						%-csch^2

%:hlp	More on the TRIG-simplier, election procedure info:

%	Preknowledge required:

%     L. H|rnfeldt, "A Sum-substitutor used as Trigonometric Simplifier",
%     Proceedings of EUROCAM 82, ed Calmet, Springer-Verlag, Lecture Notes in
%     Computer Science, vol 144, p188-195 (1982).

%  In general, if NO MULT got MAJORITY, take the sugg. closest to average!!
%  (decreases mean of num-coefficients in result)
%
%      A     B     D
%
%         C     E
%
%            F  
%
%  Kill ABC under supervision of whole triangle ADF:
%  Kill A also if BC missing, as long as DEF exist
%  Keep A only if  "     "   , and also  DEF
%  I.e. msngw=100 ,and low on BC (and def?), and use ELECT=1:st
%  Problem:what about sin-free triangles:backsearch frm cos? Yes, trigB!
%  Requesting B=C? for creating A?


% Arithmetic Routines for nums or rat nums:

(AND (GETD 'SUBTR)		
     (WARNINGL
420 "Redefining SUBTR! Name collision?"	%:war
	) )
%:w	-When loading TRIG. SUBTR dangerous name? (SUB earlier used in PSL)#
%:w

(SHPMAC (CPROGN		
  (DE SUBTR (X Y) (SPLUS X (SMINUS Y)))		% SHEEP complement for rat #
	% Minusp of rational nbr:	% (VAXDEC SMINUS SNUMINUS)
  (VAXDEC NIL % (SAMEDEF MMINUSP SMINUSP)
	% (DE MMINUSP (N) (SMINUSP N))	% also N=ratnbr	SMINUSP in LARITR.SL
	  (DE MMINUSP (N) (COND		%:mac ALREADY?
	   ((ATOM N)	(AND (NUMBERP N) (LESSP N 0)))	%:? May be non-nbr??
	   ((NUMBERP (CAR N))	(LESSP (CAR N) 0)) ))	) )
  (MOVD 'SUBTR 'SUB) )		%:mac has SUB for subtract

(DE RABS (N) (COND		% New in both: ABSolute on Rationals
  ((NUMBERP N)	(ABS N))
  (T  (SHPMAC					% Rat number is in sheep:
	(CONS (ABS (CAR N)) (CDR N))			  % (N . M), but in
	(CONSCAR N (CONS (ABS (CADR N)) (CDDR N))) )) ))  % macsyma((RAT) N M)

(OR NIL
 (DE GRABSUB (A B C) (SHPMAC
  (SMINUSP (SUBTR  (RABS (SUBTR C B))	(RABS (SUBTR C A)) ))
  (MMINUSP (SUBTR  (RABS (SUBTR C B))	(RABS (SUBTR C A)) ))  ))  )

%(DE GT!#TRM (X)
%	(OR (ATOMR X)	% Return single term, or the:
%	    (CADR X)) )	% -candidate for a num=1:st term. =num for rat.

(DE NUMINUSP (N) (AND (!$NUMBERP N) (SLESSP N 0)))
(DE NUMINUSPGT!# (X) (NUMINUSP	 % Get Nbr? from coeff
    (OR (ATOMR X)	% Return single (numeric?) term, or the:
	(SNUMPR X)	%:mac?	-sheep-number eg (3 . 7) , or the:
	(CADR X) )))	% -candidate for a num=1:st factor.Or numerator for rat

(DE TRTNF (TSR)		% TeNF-argument under TRign
  (NOT (OR (NUMINUSPGT!# (CADDR FCTR))
	   (NUMINUSPGT!# (CADDDR FCTR)) )) )

(DE SPF1!^!^ (ARG P Q)	% SP to mult two SINCOS, adding p,q exponents if ARG eq
 (PROG NIL
    (SETQ RL !*RTNL)
 L  (COND ((NOT(SETQ RL (ATSOCIA (CAADR !*RTNL) (CDR RL))))
		(RETURN NIL) )		% was (NWSPE)
	  ((EQUAL ARG (CADADR RL))
		(RPLACA!+ (SETQ RL (CDDADR RL)) P)
		(RPLACA!+ (CDR RL) Q)
		(CT!*RT)
		(RETURN T)  ) )		% was @GTSPE
    (GO L)  ))

(PUT 'SINCOS 'TSUL 'SPF1!^!^)
(PUT 'SINCOH 'TSUL 'SPF1!^!^)
(OR (EQ 'TSUL TSUP)
    (MEMQ 'TSUL TSUP)
    (PROGN (WARNINGL
422 "Active TSUP was:"	%:war
%:w	(At TRIG-load, this warning-string may come. It's in pair with 424)#
	) (PRINB TSUP)
	(SETQ TSUP '(TSUL))
	(WARNINGL
424 "-thus (SETSUP TSUP TSUL) done,since required for TRIG"	%:war
) ) )
%:w	TRIG-sumsubs (on SSUL) need canonization -SP on TSUL, so TSUL must
%:w	be run, ie EQ or MEMQ in TSUP. It wasn't in this case, so I did
%:w	set TSUP to TSUL. If your TSUP setting was crucial, adjust TSUP.
%:w	(Has nothing to do with ESUL,MSUL,PSUL or WSUL).#
%:w

%+lisp1.6
(MAPC
 '((SIN . sin)  (COS . cos)  (TAN . tan)  (COT . cot)  (SEC . sec)  (CSC . csc)
   (SINH . sinh) (COSH . cosh) (TANH . tanh) (COTH . coth) (SECH . sech)
		 (CSCH . csch))
  (FUNCTION (LAMBDA (X) (PUT (CAR X) 'NAM (NCONS (ULCASE (CDR X) NIL)))))
  )

(COND (T
(SFACTOR SINCOS SINCOH)    % So put in tsrpart by TRIG. (A must if SINCOSKEEP)
(PUT 'SINCOS 'FACTOR '((3)))	% Ranks,as no <>-input to tell HNGIR/RNQUE
(PUT 'SINCOH 'FACTOR '((3)))
(PUT 'SINCOS 'PRT 'TRPRT)
(PUT 'SINCOH 'PRT '(LAMBDA (HYP!*) (TRPRT HYP!*)))
	))
% This returns different parts of the Global "THENELSE" depending on arg IF:
%COMPILETIME		%?compiler: put in BASMAC?
%(DE IFTHENELSE (IF) (COND (IF (CADR THENELSE)) (T (CADDR THENELSE)) ))
%(DF HYPTR (THENELSE) (IFTHENELSE HYP!*))	%:sub for (HYPTR 'sinh 'sin)
(DE HYPTR (SH S) (OR (AND HYP!* SH) S))

(OR (GETD 'IFZRO)			% From FACOMP
(DE IFZRO (X Y Z) (COND ((EQ A 0) X) ((EQ B 0) Y) ((EVAL Z))))
)

(DE PRSCL (ATOM!* N) (CONS ATOM!*	% From SCLPOW
  (NCONC1  (COND ((NOT(EQ N 1)) (LIST UP N DOWN)))	ARG) ))

(DE TRPRT (ARG)		% TRig-PRT-fun put on SINCOx
  (PROG (A B)
   (SETQ ARG (CDR ARG))	% Earn 3-1=2 cdr
   (SETQ A (CADR ARG))
   (SETQ B (CADDR ARG))
   (SETQ ARG (CAR ARG))
   (RETURN (IFZRO
	(OR  (AND (ZEROP B) 1)	(PRSCL (HYPTR 'cosh 'cos) B))	% What if A=0.
	(PRSCL (HYPTR 'sinh 'sin) A)			% What if B=0. Else:
	'(NCONC (PRSCL (HYPTR 'sinh 'sin) A)
		(CONS '!  (PRSCL (HYPTR 'cosh 'cos) B)) ) ))	) )

(FLUID '(ARG DIFF VNR))
(DE !&SC (X Y Z) (OR
  (EQUAL X 0)
  (ADANS (LIST X NIL (LIST 'SINCOS ARG Y Z)))	))

(DE DIFSC (ARG P Q) (PROG (ANS)
  (COND ((EQ (KAR1 (EVAL DIFF) VNR) ARG)
		(!&SC (SHMINUS Q) (ADD1 P) (SUB1 Q))
		(!&SC P (SUB1 P) (ADD1 Q))
		(RETURN ANS) )) ))

(PUT 'SINCOS 'FDFUN 'DIFSC)	%:? Also for SINCOH !!
%(MAPC '(SEC CSC) (FUNCTION (LAMBDA (FN) (PUT FN 'EFUN (GET 'TAN 'EFUN)))))
(MAPC '(SINP COSP) (FUNCTION (LAMBDA (FN) (PUT FN 'TSUL 'SPF1!^))))

% (DECLT (SINP SIN 1 (1 . (////)) (2 . (//*) ) ) )
% (DECLT (COSP COS 1 (1 . (////)) (2 . (//*) ) ) )
%-lisp1.6

(DE TRGAD1 (NAM NAMINUS ARG N) (COND
  ((EQ N 1) (LIST (SHPMAC NAM (CAR NAM)) ARG))%MACAR in LMFAC rmakesNCONSed car
  ((AND NAMINUS		% NAMINUS=NIL signals name SEC/CSC not to be used.
	(SNUMPR N)	%:mac?	Is number	 (Or use only (NUMINUSPGT!# N)
	(SHPMAC		% -which is negative
	 (SMINUSP N)
	 (MMINUSP N)) )				% to act on (+  -1/2 A B) ? )
		(TRGAD1 NAMINUS NAM ARG (SMMINUS (DOCOPY N))) )	% SHMINUSnocmp
  (T	(LIST (SHPMAC EXP!* 'MEXPT)		% Give MACAR the atom=>(MEXPT)
	      (LIST NAM ARG) N)) ))

(DE TRGAD (NAM NAMINUS ARG N)
    (OR (EQ 0 N) (RPLACO !*RTNL (TRGAD1 NAM NAMINUS ARG N))) )

(PUT 'SINCOS 'WSUL 'TRWSB)
(PUT 'SINCOH 'WSUL (FUNCTION (LAMBDA (HYP!* P Q) (TRWSB HYP!* P Q))))

(DE TRWSB (ARG P Q) (PROG NIL
  (CT!*RT)
  (COND %(EQ 0 (SHPMAC (SMPLUS2 P Q) (ADD!* P Q)))% Minus each othr=>tan or cot
   ((AND (SNUMPR Q) %but SMPLUS2 should cpy,so bother only for ShpNUMbers%:mac?
	 (EQUAL (SMMINUS Q) P))	% that faster could be checked for P=-Q
       (TRGAD  (SHPMAC (HYPTR 'TANH 'TAN) (HYPTR '(!%TANH) '(!%TAN)))
		(SHPMAC (HYPTR 'COTH 'COT) (HYPTR '(!%COTH) '(!%COT)))
		ARG P))				    % ALWAYS use COT for 1/TAN.
   (T  (TRGAD	%:MAC (SIN/COS has no %-prefix)	    % What to show for POSpwrs-
	    (SHPMAC (HYPTR 'SINH 'SIN) (HYPTR '(SINH) '(SIN)))	% -of SIN
	    (AND SECCSC (SHPMAC (HYPTR 'CSCH 'CSC) (HYPTR '(!%CSCH) '(!%CSC))))
	    ARG P)	% -Above: NEG sin-powers to show as CSC only if
       (TRGAD		%  the SECCSC-switch is on!
	    (SHPMAC (HYPTR 'COSH 'COS) (HYPTR '(COSH) '(COS)))	% -of COS
	    (AND SECCSC (SHPMAC (HYPTR 'SECH 'SEC) (HYPTR '(!%SECH) '(!%SEC))))
	    ARG Q) ) )			% Above: Neg cos-powers.
  (RETURN (GTSPE)) ))

% (DEFPROP SINCOS (LAMBDA (L) (LIST
%   (LIST EXP!* (LIST @(SIN) (CADR L)) (CADDR L))
%   (LIST EXP!* (LIST @(SIN) (CADR L)) (CADDR L))
%  ))  LMFAC)

(PUT 'SIN!- 'SMPFN '(LAMBDA (TEN) (SIN!-2 (CDDR TEN))))
%OKMACLIne(OR (GETD @PLUS2) (DEFUN PLUS2 MACRO (L) (RPLACA L @ADD))) %(No)
(DE EXPTAWARN (N M) (SMPLUS2 N (OR (SNUMPR M) (STERROR 799 "Tell LH")))) %?
(SETQ EXPTADDER!* (SHPMAC 'EXPTAWARN 'ADD))	% SMPLUS2
%:h Do: (SETQ EXPTADDER!* 'PLUS2)	-if you only expect NUMERIC exponents.

(DE RPLACA!+ (L N) (RPLACA L (FUNCALL EXPTADDER!* N (CAR L))))	%:b

(DE SIN!-2 (X) (PROGN (RPLACA!+ X -2) (RPLACA TEN (OR HYP!* 'SINCOS))))
(DE SIN!+!+ (P Q) (PROGN
  (RPLACA!+ (CDR (RPLACA!+ (CDDR TEN) P)) Q)
  (RPLACA TEN (OR HYP!* 'SINCOS)) ))

(PUT 'SIN!- 'SMPFN '(LAMBDA (TEN) (SIN!-2 (CDDR TEN))))

(PUT 'SC!+2!-2 'SMPFN '(LAMBDA (TEN) (SIN!+!+ 2 -2)))
(PUT 'SC!+0!-2 'SMPFN '(LAMBDA (TEN) (SIN!+!+ 0 -2)))
(PUT 'SC!-2!+2 'SMPFN '(LAMBDA (TEN) (SIN!+!+ -2 2)))

(PUT 'SC!-4!+4 'SMPFN '(LAMBDA (TEN) (SIN!+!+ -4 4)))
(PUT 'SC!-4!+2 'SMPFN '(LAMBDA (TEN) (SIN!+!+ -4 2)))
(PUT 'SC!-4 'SMPFN '(LAMBDA (TEN) (SIN!+!+ -4 0)))

%OKM+1.6(DEFPROP SINZ DIMENSION PRTEN) 
%(PUT 'SINZ 'DEF  '(ALG (H P Q) NIL (1 NIL (SC!-2!+2 H P Q))
%			(-1 NIL (SIN!- H P Q))	(1 NIL (SINCOS H P Q)) ))
%(ON NOMSG) (PDEF SINZ)<SINCOS H P Q>+<SC/-2/+2 H P Q>-<SIN- H P Q>$(OFF NOMSG)

(DE HSUMS (P HYP!* !*DSUM TENF MISW NZA!* COLLAPSUM ELCT) % Call SUMS1 with HYP
  (COND ((NOT P) NIL)	% (Switch not on)
	(HYP!*	% For trigHYPerbolicus, it is:	MINUS sinh^2+cosh^2=1
	     (SUMS1 (CONS '(-1 NIL (SINCOH H P Q)) (CDR !*DSUM)) %erbolic SUM
		    (NCONS (CONS '(SINCOH H P Q) (CDAR TENF)))	% -and TsrFtn
				MISW NZA!* COLLAPSUM ELCT))
	(T   (SUMS1 !*DSUM TENF MISW NZA!* COLLAPSUM ELCT)) ) )	% -Or trig-dito

(DE SUTRG (HYP!*) (OR	% SSUL SP-fun for SINCOS, or SINCOH (if HYP).
 (HSUMS TRIGN HYP!*
% New DSUM that only does x0 => 0, also if just s^2, conctng 4 pwrs away
% Requires ELECT that choses to kill 1:st, ie the sin^2 term:
	'((1 NIL (SINCOS	H P Q))	% +sin^2.. 	4 0 was, for x0^2>0:
	  (1 NIL (SC!-2!+2	H P Q))	% +cos^2..	2 2		2
	  (-1 NIL (SIN!-	H P Q))	% ..-1  = 0	2 0		-2
	  (0 NIL (SC!-4!+4	H P Q))	%  (dummy,	0 4		1
	  (0 NIL (SC!-4!+2	H P Q))	%  just for	0 2		-2
	  (0 NIL (SC!-4		H P Q)) )%   scope)	0 0		1
	'(((SINCOS H P Q) . TRTNF))
		%LAMBDA (TSR)
		%   (NOT (OR (NUMINUSPGT!# (CADDR FCTR))
		%	    (NUMINUSPGT!# (CADDDR FCTR)) ))
	'((110 . 100) (NIL . 45) (NIL . 35) (NIL . 18)	% 110,50,40,25,
	  (NIL . 15) (NIL . 5))				% 15,5
	-18		% 100-<sum of msgw for rest of terms,aftr 1:st>
	NIL		% COLLAPSUM
	(FUNCTION (LAMBDA (F E D C B A) (PROGN	% Election program
	% (BREAK ELECT6)
	  (COND	((EQ (SETQ COSSEE (CADDAR (CADDR !*SPTR)))
		     (CAR COSSEEN) ))
		(T	(SETQ COSSEEN (CONS COSSEE COSSEEN))) )
	  (IFPE (AND (EQ 0 D) (EQ 0 E) (GRABSUB A B C))
% If B,C=0 go ahead anyway,if there is D,E,F-coefs. Ie use B ONLY when DE=0
		B A) ))) )
% Above new Msngw'ts that allows B C missing, if DE are there
% Kill A if:   (o=allowed to be zero)            NOT:
%     A B D  A 0 D    A 0 D    A B D   A 0 0    A 0 0
%      C E    0 E    ? 0 E      0 o     C 0      0 E
%       F      F      ? 0
% Case B,C=truly equal (=unchanged by A' or DEF):  A B 0  ,ie these:A'DEF=zero
% Then kill BC,to prize of remaining A.        A'=0 B 0
% Elect should see if B and C voted same(=same), and if A'DE all voted mult=0
% Then use BC's vote, not A's!
%
% If A missing:?  
% And also DE:then make A if that kills Both B&C (Search down left, to check?)
% Old DSUM that did x0^2 => 0:
%		(1 NIL(SINCOS		H P Q))	4 0
%		(2 NIL (SC/-2/+2	H P Q))	2 2
%		(-2 NIL(SIN-		H P Q))	2 0
%		(1 NIL (SC/-4/+4	H P Q))	0 4
%		(-2 NIL(SC/-4/+2	H P Q))	0 2
%		(1 NIL (SC/-4		H P Q))
%	(QUOTE ((40.100) (40.60) (40.20) (NIL.40) (NIL.40) (NIL.40)))
% all=200:(QUOTE ((200.100) (nil.200) (NIL.200) (NIL.200) (NIL.200) (NIL.200)))
% -120
% successrecord:      nbr of ev's(or stuck on # of terms) for examples:
% sumsubsfunction:     x1 xs xc x0 x1^2 xc^2 x0^2  x(1c0)^3 x(1sc)*x0^2
% TRIGN off(just x0>0)  1  #  1  1  1    2    #    1 3 #5   (1,1,#4)
% MSNGW:All=200:        1  #  2  1  1    2   ==1   1 3 #5     ==1 
% Nasty ones:	       (xcs1)^3
% TRIGHARD=T	       20s	x1^20=20s/w fast (expand=1)

  			% sin<=COS - 1 Backwards(collapsum)if EQUAL koe onCOS&1
 (AND TRIGB (SUMS1	%? DONT use HSUMS here; fails to get sinHYPERBOLIC!
	(HYPTR
	 '((1 NIL (SINCOH H P Q))    %  cosH^2..  Require cos- and "1"-term get
	   (-1 NIL (SC!+2!-2 H P Q)) % -sinH^2..  same votes in order to kill
	   (-1 NIL (SC!+0!-2 H P Q)))%   ..-1 =0  them,Srch BACKWARDS,insrt SIN
	 '((1 NIL (SINCOS H P Q))    %  cos^2..	  Require cos- and "1"-term get
	   (1 NIL (SC!+2!-2 H P Q))  % +sin^2..	  same votes in order to kill
	   (-1 NIL (SC!+0!-2 H P Q))))%  ..-1 =0  them,Srch BACKWARDS,insrt SIN
	(HYPTR
	'(((SINCOH H P Q) LAMBDA (TSR)
	   (OR		%	(BREIF 'SEEN!?)
	     (NOT(MEMQ FCTR COSSEEN))
	     (PROGN (SETQ COSSEEN (SHPMAC (DELQIP TSR COSSEEN)
					  (DELQ   TSR COSSEEN) ))
		    NIL) ) ))
	'(((SINCOS H P Q) LAMBDA (TSR)
	   (OR		%	(BREIF 'SEEN!?)
	     (NOT(MEMQ FCTR COSSEEN))
	     (PROGN (SETQ COSSEEN (SHPMAC (DELQIP TSR COSSEEN)
					  (DELQ   TSR COSSEEN) ))
		    NIL) ) )) )
	'((80 . 100) (80 . 20) (NIL . 80))
	-140		% 60=Bad,must include 1:st msgw when COLLAPSUM
	T	% COLLAPSUM
	(FUNCTION (LAMBDA (C B A)
	    (IFPE (GRABSUB A B C)
		  B  A) )) ))
% Don't create a sin-trm which would have remove-condition! (Before C)
% thus kill cos only? if (sin-vote=0) cos&1vote=same sign=unomious
% ((COND ((EQ A B) A) (T 0)))	% ELECT-or requesting voteeq
%(LAMBDA (A B C) (COND((ZEROP (ADD* B(CAR C))) (CAR C)) (T 0))) % Dito ELECtor


 (HSUMS TRIG0 HYP!*	% Simplest, backup sumsubs,considering only 3 trm scope
	'((1 NIL	(SINCOS	  H P Q))
	  (1 NIL	(SC!-2!+2 H P Q))
	  (-1 NIL (SIN!-	  H P Q)))
	'(((SINCOS H P Q)))
	'((80 . 100) (80 . 20) (NIL . 80))
	-60 NIL NIL) ))

(PUT 'SINCOS 'SSUL (FUNCTION (LAMBDA (ARG P Q)
     (COND ((SUTRG NIL))) )))		% Stdrd COND.. so extendable

(PUT 'SINCOH 'SSUL (FUNCTION (LAMBDA (ARG P Q)
     (COND ((SUTRG 'SINCOH))) )))	% Stdrd COND.. so extendable

(DE FSIMP!-SU (L) 
 (PROG (TSUBS SSUBS NFSMP NCSMP)
    (SETQ NFSMP (SETQ NCSMP (SETQ SSUBS T)))
    (RETURN (FSIMP L)) ))

% Unused also in MacLisp????:
%?MACLIne(DE $NEXPAND (X) (PROGN (PRINC (1- (LENGTH (SETQ X ( /$EXPAND X)))))
	% +MACLIne		(PRINC @" terms")	X))
	% +MACLIne(SETQ TRIGSUMEXPAND T)

(DE HNGSINCO (ARG FN FA)	% HaNG SINCOs/h for arguments used, on FA
    (AND ARG		% If REad SIn etc, arguments used are stored here
	 (SETQ NOREN (MAPCAR ARG	% Make all terms contain such trig:
		(FUNCTION (LAMBDA (H) (LIST FN H 0 0))) ))
	 (MAPC (CDR FA) (FUNCTION(LAMBDA(X) (NCONC X (COPY NOREN)))))  ) )

	% Takes and returns SHEEP/MACSYMA formate.Cf. SUMS frm FACTOR
(DE TRIGSUM3 (FAC CNT)
 (PROG (SINCOS SINCOH TSUBS NOREN NCSMP NFSMP SUMSG)	% canonize,sumsubs
    (SETQ TSUBS (SETQ NOREN T))
	%? +MACLIne (DE SIMP (X) (SIMPLIFY X))
    (SETQ FAC (REASU (COND			% Read into FAC-formate
	((OR (EQ TRIGSUMEXPAND 'ALL)	% EXPAND first!!
	     (AND TRIGSUMEXPAND (NOT (MPLUSP FAC))) )
			(!$EXPAND FAC))
	(T FAC) )))
    (HNGSINCO SINCOS 'SINCOS FAC)
    (HNGSINCO SINCOH 'SINCOH FAC)
%+MACLIne  (DE SIMP (X) (/$EXPAND X))	% Expand the coeff's before sumsbs
    (SETQ FAC (FSIMP FAC))			% Canonize, running TSUBS
 L  (SETQ COSSEEN (SETQ SUMSG NIL))		% Reset
    (RPLACDNIL (CDDDDR (CDDR !*SPTR)))		%? fix???
    (SETQ FAC (FSIMP!-SU FAC))			% Just Sumsubst:In/out canon
    (AND SUMSG					% SUMSG=signal of success,thus
	 (RPTMAXW (MINUSP (SETQ CNT (ADD1 CNT)))% redo,unless repeat count max?
		  'TRIG 'TRIGHARDRPT)
	 (GO L))
%?+MACLIne  (DE SIMP (X) (/$EXPAND X))	% (DE SIMP (X) ($EV X $NOEVAL))
    (RETURN FAC)  ))

(SHPMAC
(DE TRIGSUM2 (FAC WSUBS) (LMFAC (WSUBF 'WSUL	% Result into LaM-formate
   (TRIGSUM3 FAC (OR (AND TRIGHARD (MINUS TRIGHARDRPT)) -1)) ))) % Init count

(DE TRIGSUM2 (FAC WSUBS) (MAFAC
   (TRIGSUM3 FAC (OR (AND TRIGHARD (MINUS TRIGHARDRPT)) -1)) ))	)

(SHPMAC	(PROGN		% Only Shp:
% TRIG on S-heepformate (turn on FAC):
(DE TRIGS (FAC) (TRIGSUM2 FAC (NOT SINCOSKEEP)))% WSUBS convrt SINCOS to sin,..
(DE TRIGSE (FAC) (TRIGS (EVAL FAC)))		% E-val also,to grab tsrcompnt

(QSET '!*COMP NIL)
(PUSHV !*COMP NIL)	%:cu Shield Compilation since shpbug	%:IF
(DE DOLIN (LINITFN!* WSW) (PROG (SPLIT!*)
  (SETQ SPLIT!* T)	% Cause ALGs be looked for in arrays and not under DEF
  (RETURN (EVALCONS
	(IFPE WSW 'WLINIT 'LINIT)
	LST)) )) % LINIT uses LINITFN!*

% **** MAIN FUNCTIONS:	%okSlisp
		(PUSHV !*MSG NIL)
(DF  TRIG (LST) (PROG (FAC) (SETQ FAC T) (RETURN (DOLIN 'TRIGSE NIL))))
(DF WTRIG (LST) (PROG (FAC) (SETQ FAC T) (RETURN (DOLIN 'TRIGSE T))))
		(POPV !*MSG !*COMP)

(OR (BOUNDP 'HS) (REMD 'WTRIGLOOP))	% To allow redefinition:
(AUTOLD TSRTRD WTRIGLOOP)	% For demo. Loads file tsrtrD with XS,XC..
				%-Slisp
%(DE TRIG (FAC) (TRIGSUM2 FAC T))
%(DE WTRIG (FAC) (PROGN (PRT (TRIGSUM2 FAC T)) NIL))
	)	% End shp-progn/New for Mac:
(PROGN
(DF TRIGSUM (FAC) (PROG (DEN)
  (SETQ DEN (DENOM (SETQ FAC (TOTALDISREP (MEVAL (CAR FAC))))))
  (RETURN (COND
     ((AND (MPLUSP DEN) (MPLUSP (SETQ DEN (TRIGSUM2 DEN T))))
		(DIV (TRIGSUM2 (NUM FAC) T) DEN))
     ((TRIGSUM2 (DIV (NUM FAC) DEN) T)) ))))

(DF TRIG1 (X) (EVALIST (FUNCTION TRIGSUM) (CONS '!$EXPAND X)) )
	)	)	% End SHPMAC
(SETQ LTENI NIL)
(POPV !*MACROEXPAND)
%(DF LOD (L) (LOAD (COND (L (SETQ LODARG L)) (T LODARG))))
%(DE BAK NIL (BAKTRACE NIL))
% TSRTR.SL end
