%:fil QTCOM2.SL 	TensorCOMPiler; 2 or more (possibly sym) sum indices
% Copyright (c) 1992 Lars Hornfeldt,	Phys. dep. Stockholm Univ.,	Sweden.

% TCOMP Translates a DEF to a Lisp-program, that can perform contractions etc
% in the DEF in the most efficient way, exploiting symmetries of tsrs.

% This is the part that exploit the tsr-symmetries, in DEFs with 2dmys or more

(COND (T	% Avoid compilation! (So code may be GRINDed into .BLF-file)
		% **** START OF COND ****

(DE LESS!* (CL) (COND
   ((NOT CL) NIL)
%  ((APPLY (FUNCTION GREATERP) (CAR CL)) NIL)	% Lacks one eval, so gives:
%  ((APPLY (FUNCTION LESSP) (CAR CL)) T)  % *2 bad arg for LESSP,for RIExchsym
   ((EVALCONS 'GREATERP (CAR CL)) NIL)
   ((EVALCONS 'LESSP (CAR CL)) T)
   (T (LESS!* (CDR CL))) ))

(DE BOU1 (CL) 
 (COND
   ((LESS!* (CDR CL)) (ADD1 (EVALCADR (CAR CL))))
   ((EVALCADR (CAR CL)))))

(DE !*MIN (A B) (COND ((GREATERP A B) B) (A)))

(OR (GETD 'MIN)
 (DM MIN (L) (EXPAND (CDR L) '!*MIN))	%???Available?
 )
))			% ******* end of cond **********
(DE BOUZ (CL) (PROG (Z ZR)
    (SETQ ZR (CADAR CL))
    (SETQ CL (CDR CL))
    (RETURN 
     (MAPCAR CL 
      (FUNCTION (LAMBDA (C1)
	(PROG (Z)
	   (SETQ Z ZR)
	   (SETQ ZR (CADR C1))
	   (RETURN 
	    (LIST (CAR C1) 'COND (LIST (LIST 'ZEROP Z) ZR) 
%				 (NCONS 'DIM)
				 (LIST T DEFAULTDIMENSION!*)
		)))))))))

(FLUID '(!*CIX L!* P!* X!* TEXPR KOE CL SYMOP LLIM LLST !*N FX
		!&SUMV DEBUG CDEF))
(NEWSWITCHES (
MKTEN "For TCOMP to save symoperated tsr as nw object (Exprimntal)")) %:nsw

%(DE MEMQDEPTH (X!* L) (MEMQDEPX!* L))	%:b As MEMQ, but to any Depth
%(DE MEMQDEPX!* (L) (AND (PAIRP L)	%:b MemqDepth of fluid X!* in L
%  (OR	(AND (EQCARE L X!*) L)
%	(MEMQDEPX!* (CAR L))		% Depth first
%	(MEMQDEPX!* (CDR L))  ) ))

%(DE IFPCONS (P A L) (IFCONS (AND(FUNCALL P A)A) L))%:b? IF Pred CONS A, else L

%(DE MEMCL (X!*) (CARDOWN(MEMQDEPX!* CL)))% Return cix if memqDpth in CycleList
(DE MEMCL (X!*)		% Return cntrction-ix if member in CDR of CycleList
 (PROG (P!*)
    (MAPC CL (LAMBDAX (AND (MEMQ X!* (CDR X)) (SETQ P!* X!*))))
    (RETURN P!*) ))

(COMMENT
(DE RCLDL (CL DL)	% Wrong. Adds
 (AND DL (IFCONS (MEMCL (CAR DL)) (RCLDL CL (CDR DL)))))	)

(DE RCLDL (CL DL)	% Remove from Dmylist,those in (cdr of any) Cyclelist:
 (PROG (OUTDL !*CIX)
    (SETQ DL (REVERSE DL))
 L  (COND
      ((NOT (MEMCL (SETQ !*CIX (CAR DL))))
		(SETQ OUTDL (CONS !*CIX OUTDL))))
    (COND ((SETQ DL (CDR DL)) (GO L)))
    (RETURN OUTDL) ))

(DE RCLBL (CL BL)
 (MAPCAR BL
  (FUNCTION (LAMBDA (PAIR)
    (COND ((MEMCL (CAR PAIR)) '(NIL)) (T PAIR))))))

(DE SC1EX (C1 TEXPR)
 (PROG (ORG)
   (SETQ ORG (CAR C1))
L  (COND
     ((SETQ C1 (CDR C1))
	(SETQ TEXPR (SUBST ORG (CAR C1) TEXPR)) (GO L))
     (T (RETURN TEXPR)))))

(DE SCLEX (CL TEXPR) (PROGN
  (MAPC CL (FUNCTION (LAMBDA (C1) (SETQ TEXPR (SC1EX C1 TEXPR)))))
  TEXPR))

(DE SHIR (A B)		%:b? SHIft Right (Used in eg NAMI1/TEDEF) Imprtant???
 (PROG (P)
    (SETQ P (CDDR B))
    (RPLACD A (RPLACD (CDR B) (CDR A)))
    (RPLACD B P)))

(DE EQLL (CL) (OR
  (NOT CL)
  (AND (EQL (CAR CL)) (EQLL (CDR CL))) ))

%(SETQ TRCRL '(SUM!*S1 ANSR OUT))
(SETQ TRCNBR 1)
(SETQ MKTEN NIL)

(DE INVPOP1 (C1 EXPR)
 (PROG (LST)
   (SETQ EXPR (SUBST 'NO1 (SETQ LST (CAR C1)) EXPR))
L  (COND
	((NOT (SETQ C1 (CDR C1))) (RETURN (SUBST LST 'NO1 EXPR))))
   (SETQ EXPR (SUBST LST (SETQ LST (CAR C1)) EXPR))
   (GO L)))

(DE INVPOP (CL EXPR) (PROGN
  (MAPC CL (FUNCTION (LAMBDA (P1) (SETQ EXPR (INVPOP1 P1 EXPR)))))
  EXPR))

(DE SYMA (CL EXPR) 
 (PROG (K1 N PEXPR SEXPR)
   (SETQ K1 KOE)
   (SETQ SEXPR EXPR)
   (SETQ N (SUB1 (LENGTH (CAR CL))))		% INVPOP use SUBST which on
L  (SETQ PEXPR (INVPOP CL (IFP			% late Culisps avoids through-
	(EQ (SUBST 1 2 MEXTLIS!*) MEXTLIS!*)	% out copy. Then we must
	(COPY EXPR) EXPR)))			% complement with that.
   (NCONC SEXPR
    (COND
	((EQ K1 1) PEXPR)
	((MULTSS (NCONS (LIST K1 NIL)) PEXPR))))
   (COND ((ZEROP (SETQ N (SUB1 N))) (RETURN SEXPR)))
   (SETQ K1 (DOMULC KOE K1))		%	(!&MTIM KOE K1)
   (SETQ EXPR PEXPR)
   (GO L)))

(DE GETSR (TSRL)
 (PROG (STENL L!* P!*)
   (SETQ LLST (NCONS NIL))
L  (COND
	((NOT (CDR TSRL)) (RETURN STENL))
	((ATOM (CADR TSRL)) (GO SHIR)))
   (SETQ L!* (CDADR TSRL))
   (MAPC CL
    (FUNCTION (LAMBDA (C1)
	(MAPC C1 (LAMBDAX (AND (MEMQ X L!*) (SETQ P!* T)))) )) ) % Dummy
   (COND
     (P!*
	(SETQ P!* NIL)
	(SETQ STENL (CONSCAR (CDR TSRL) STENL))
	(SETQ TSRL (CDR TSRL))
	(GO L)))
SHIR(SHIR LLST TSRL)
    (GO L) ))

(DE SYMAT (TSRL) (PROG (STENL TNAM TSR) (RETURN (COND
   ((AND MKTEN SYMOP (SETQ STENL (GETSR TSRL)))
	(SETQ TNAM (CONCATIDL  (REVERSE(CONS KOE(MAPCAR STENL CAR))) ))
%(INTERN(COMPRESS(NCONCL(MAPCAR(REVERSE(CONS KOE(MAPCAR STENL CAR)))'EXPLODE))))
	(EVAL
	 (LIST (FUNCTION DF) TNAM '(L)
	  (LIST 'CONS (!&QNNR TNAM) '(MAPCAR L 'EVAL))  ))
	(SETQ TSR (CONS TNAM (APPENDL
	   (MAPCAR (REVERSE STENL) 'CDR)  )))
	(REVERSE (CONS TSR LLST)) )
   (T	(SYMA CL (MAPCAR TSRL (FUNCTION COPY!<)))) ))))

(DE SUM!*S1 (TOT0)
 (PROG (SYMOP DUML BOUL KOE CL TOT1 TOT2)
%  (TRCR NBR NIL (COND ((EQ TRCNBR NBR) (TRC SUM!*S1) (TRACE SYMAT))))
%  (TRCR SUM!*S1 '((CAR TOT0)) (PRNTR TOT0))
   (COND
      ((SETQ SYMOP (CAR TOT0)) (SETQ X!* T))	% eXtra symops?
      (T (RETURN (NCONS TOT0))) )
   (SETQ DUML (CADR TOT0))
   (SETQ BOUL (CADDR TOT0))
   (SETQ KOE (CAAR SYMOP))
   (SETQ CL (CDAR SYMOP))
   (SETQ SYMOP (CDR SYMOP))
   (COND ((EQLL CL) (GO IDENTOP)))
   (SETQ TOT0 (CADDDR TOT0))
   (SETQ TOT1
    (LIST SYMOP DUML
     (CONS
      (CONSCAR (CAR CL)
	(COND	((CDR CL) (ADLFN BOU1 LESS!*) (LIST 'BOU1 (!&QNNR CL)))
		((CADAR CL)) ) )
      (APPEND (BOUZ CL) BOUL) )
     (LIST (CAR TOT0) (SYMAT (CADR TOT0))) ))
   (COND
      ((AND (OR (NOT (NUMBERP KOE)) (ONEP KOE))
	    (ZEROP (DIFLEN (!*WASH (LAMBDAX (EQCAR X (CAAR  CL))) BOUL)
			   (!*WASH (LAMBDAX (EQCAR X (CADAR CL))) !*WSHL) )) )
		(GO TRACE) ))
   (RETURN (NCONS TOT1))
TRACE
   (SETQ TOT2 (LIST	(SCLEX CL SYMOP)
			(RCLDL CL DUML)
			(RCLBL CL BOUL)
			(SCLEX CL TOT0) ))
   (RETURN (LIST TOT1 TOT2))
IDENTOP
   (COND
     ((OR (NOT (NUMBERP KOE)) (ONEP KOE))
	(RETURN (NCONS (CONS SYMOP (CDR TOT0)))) )) ) )

(DE REMCOP (L)
 (PROG (LFT L1)
L (COND ((NOT L) (RETURN LFT))
	((MEMBER (SETQ L1 (CAR L)) (SETQ L (CDR L))) (GO L))
	(T (SETQ LFT (CONS L1 LFT)) (GO L)) ) ))

(DE !&TMSM (KSM)
 (PROG (K SM)
   (SETQ K (CAR KSM))
   (SETQ SM (CADR KSM))
   (COND ((NOT (EQ 'LIST (CAR SM))) (RETURN (!&DMLC K SM))))
   (SETQ KSM (CDDR SM))
   (COND ((NOT (CDDR KSM))
	 (RETURN (LIST 'TMSM2 K (CAR KSM) (CADR KSM))) ))
   (RETURN (LIST 'TMSMN K SM)) ))

%Make Upper Boundaries for dummies in Reversed DUMmyList.BOUR=(nil (Ix1.Ub1)..)
(DE MKUB (DUML BOUR) 
 (PROG (DUM UB1 B1 BOUL OUTUB)
   (SETQ DUM (CAR DUML))
   (SETQ BOUL (NCONS NIL))
L  (COND
     ((NOT (CDR BOUR)) (GO MKMIN))
     ((EQ DUM (CAADR BOUR))
      (SETQ UB1 
	(CONS (COND
	   ((AND (PAIRP (SETQ B1 (CDADR BOUR)))
		 (EQCARE B1 'BOU1) )
			(LIST 'BOU1 (!&QNNR (REMCOP (REVERSE (CADADR B1))))))
	   (T B1))
	   UB1))
      (SETQ BOUR (CDR BOUR))
      (GO L) ))
   (SHIR BOUL BOUR)
   (GO L)
MKMIN 
   (SETQ OUTUB 
    (CONS 
     (COND
	((NOT UB1) (GTDIM DUM))
	((CDR UB1)
		(ADLFN !*MIN)
		(CONS (COND ((CDDR UB1) (ADLFN MIN) 'MIN) ('!*MIN)) UB1) )
	((CAR UB1)) )
     OUTUB) )
   (COND((SETQ DUML (CDR DUML))
		(SETQ DUM (CAR DUML))
		(SETQ BOUR BOUL)
		(SETQ BOUL (NCONS (SETQ UB1 NIL)))
		(GO L) )
	(T	(RETURN OUTUB)) )))

%(OR (GETD 'NOZDO) (LOAD "SUMBOU"))

%MaKe LowrBoundaries for Revrsd DUMmyList,and Revrsd Upperbndlst,Out=RevLowBndL
(DE MKLB (DEFAULTDIMENSION!* DUML U)	% Bindprotect global
 (PROG (OLDIM X ANS!* !&SUMV)
   (SETQ ANS!* 0)
   (SETQ OLDIM DEFAULTDIMENSION!*)	%???Best init spindim etc low too!
   (SETQ DEFAULTDIMENSION!* 1)		% -to reach lowlim fast if many dmys!
   (SETQ !&SUMV '''(SETQ LLIM (CONS '!; (EVALCONS 'LIST DUML))))
%		    (CONS '!; (MAPCAR DUML (FUNCTION EVAL)))
   (SETQ X (!&SUMB DUML '(0 0 0 0 0 0 0 0) U))
L  (EVAL X)
   (COND	% If ANS, then Lowlim was ok
    ((NOT (OR (ZEROP ANS!*) (NULL ANS!*)))	%?????	%:cu	%:tmp
	%(ANS..)		% was ANS, but ADANZ now ading to 0, not NIL
	 (AND(GREATERP DEFAULTDIMENSION!* OLDIM)
	     (STSWAR
350 %:war "Lowest dim %p to make summation nonzero"
		(LIST DEFAULTDIMENSION!*) ) )
%:w	Indices contracted over occured on (anti-)symmetric index positions.
%:w	TCOMP exploits that (using DECLT-setup property SYMOP, so to avoid
%:w	the mechanism, the command (REMPROP sytsr 'SYMOP) can be done),
%:w	creating a summation with inequalities between the dummies when
%:w	summating, eg i < j, or more complicated for eg the RIE-symmetry.
%:w	For such an inequality to have any fulfilling index values, the
%:w	dimension (max ixvalue + 1) must have some minimal value.
%:w	  Eg inequality i < j, has no satisfying ix-pairs if i,j only may
%:w	attain the value 0, so that summation is identically 0 if the
%:w	dimension is 1.  Symmetric tsr S contracted cause a summation of
%:w	Sij... with i<j, plus a summation Sii.., of which again the first
%:w	kind of summation might cause the above message - which thus may
%:w	occur also for symmetric summation, not only antisymmetric.
%:w	  It is just a WARNING/REMARK, given when current DEFAULTDIMENSION!*
%:w	is so low as to make the sum identically zero. The sum wont be
%:w	zero if the bulf is used when DEFAULTDIMENSION!* (or corresponding)
%:w	in some later situation has a higher value.#
%:w
	 (RETURN (CDR LLIM))	))
   (SETQ DEFAULTDIMENSION!* (ADD1 DEFAULTDIMENSION!*))	%Must start from higher
   (GO L) ))


%:debug For TRCR see DEC10.STS
%:debug (DF TRC (L) (MAPC L ..))
%:debug(DE PRNTR (L) (PROG NIL
%:debug    (MAPC (CADDR L) (FUNCTION PRINT))
%:debug    (COND (PRNTR	(TERPRI)	(PRIN1 (CADDDR L)) )) ))

% Add NoZerodo on result of FSimping. X has sum due to permuting with symops
(DE !&NZFS (X) (PROG (SM) (RETURN % X = (Sytsr (trm1 trm2 trm3..)) -all /w ix
  (COND		% Just one term, after prmuting?   Then put sytsr back into
   ((NOT (CDADR X))	(RPLACO (CDAADR X) (CAR X))	% that singe term
			(!&QNNR (QL!<F1 (CAADR X))) )	% and translate term
   ((EQ 0 (SETQ SM (FSIMPNOREN (CONSCADR NIL X))))	% Fsmp (trm1 trm2..)
		(STSWAR
351 %:war "Asym/sym contraction made term zero! Do indicial presimp?"
		 )
		0)
   ((CDDR SM)
	(!&QNZD (CAR X) (!&PLSM (MAPCAR (CDR SM) 'QL!<F1))) ) % Several trms
   (T	(!&NZFS (LIST (CAR X) (CDR SM)))) ) )))	% Collapse to 1 trm. Go start
%:w	TCOMP detected a term was zero due to contraction between symmetric
%:w	indexpositions, and antisymmetric dito. Do (ON SYMZERO) and SDEF
%:w	the expression. That might kill off the term already indicially.
%:w	Then TCOMP that simpler formula instead.#
%:w

(SETQ !&SUMV '(!&NZFS (CADR L!*)))

%(DE !&SUMB (D N U) (COND	%:old
%   ((CDR U) (LIST 'SUMBOU (!&QNNR (CAR D)) (CAR N) (CAR U) 
%		(!&QNNR (!&SUMB (CDR D) (CDR N) (CDR U)))))
%   ((LIST 'SUM!*1 (CAR U) (EVAL !&SUMV)))))

%(DE ZSUMB (Z S) (COND ((EQCARE !&SUMV 'QUOTE) Z) (T S)))
(DE ZSUMB (Z S) (IFPE (EQCARE !&SUMV 'QUOTE) Z S))

(DE !&SUMB (D N U) (COND	% Expand (Dmys LBnbrs UBxprs) to nested SUMBOUs
% (CDR U)
 ((CDR U)
    (LIST (ZSUMB 'ZUMBOU 'SUMBOU)
	  (!&QNNR (CAR D))	(CAR N) 	(CAR U)
	  (!&QNNR (!&SUMB (CDR D) (CDR N) (CDR U))) ))
 ((MEMQ (CAR D) '(!*1 !*0))		% Was *1, normal:
	(LIST (ZSUMB 'ZUM!*1 'SUM!*1) (CAR U) (EVAL !&SUMV)) )
%(T (LIST (ZSUMB 'ZUM!*1 'SUM!*1) (CAR U) (EVAL !&SUMV) ))
%(T (LIST (ZSUMB 'ZUMB1  'SUMBOU) (!&QNNR (CAR D))	0	% Not !*1 :
%				  (CAR U) (EVAL !&SUMV) ))
 (T (LIST (ZSUMB 'ZUMB1 'SUMBOU) (!&QNNR (CAR D))	0	% Not !*1 :
	(CAR U) (EVAL (ZSUMB '(EVAL !&SUMV)
%			     '(LIST 'ADANZE (EVAL !&SUMV))
			     '(RPLACADRLIST (EVAL !&SUMV) 'ADANZ)
 )) )) ))

%DE RPLACACONS (L X) (RPLACA L (CONS X (CAR L))))	%
(DE RPLACALIST (L X) (RPLACA L (LIST X (CAR L))))	%:b
(DE RPLACADRLIST (L X) (PROGN (RPLACALIST (CDR L) X) L))	%:b
% Turn (QUOTE	     (SSIMP ..)) = L	by (RPLACADRLIST L 'ADANZ) into:
% into (QUOTE (ADANZ (SSIMP ..)))
% (DE ADANZE (X) (ADANZ (EVAL X)))

  % SUMmate over *1 [from its crnt val to zero] : EXpression
(DE ZUM!*1 (!*1 EX) (PROG NIL
 L (COND ((MINUSP (SETQ !*1 (SUB1 !*1)) ))
	 ((ADANZ (EVAL EX))	(GO L)) )))

  % SUMmate over *1 [from its crnt val to zero] : EXpression
(DE ZUMB1 (D L U EX) (PROG NIL
   (SET D U)
 L (COND ((MINUSP (SET D (SUB1 (EVAL D)))))
	 ((ADANZ (EVAL EX))	(GO L)) ) ))

  % SUMmate over Dmy [frm Low to Upper BOUndary] : EXpression
(DE ZUMBOU (D L U EX) (PROG NIL
    (SET D U)
L   (COND ((NOT (GREATERP L (SET D (SUB1 (EVAL D)))))
		(EVAL EX)
		(GO L) ))))

% A main routine: Create summation that exploits Symmetries
% In: (SYMoperators	Dummies   SYmmetric-tensor	Rest-of-the-alg-term)
(DE SUM!*S (L!*)	% Out: Nested (SUMBOU(SUMBOU...(SUM*1 ..fsimpedXpr)))
 (PROG (BOUL TOTL X!*)
   (SETQ TOTL (NCONS (LIST (CAR L!*) (CADR L!*) BOUL (CADDR L!*))))
L  (SETQ X!* NIL)
   (SETQ TOTL (MAPCAN TOTL (FUNCTION SUM!*S1)))
   (COND
     (X!* (GO L))
     ((MAPC TOTL 
	(FUNCTION (LAMBDA (TOT1)
	 (COND
	   (T %(CDR (SETQ X!* (CADR TOT1)))   % Several dmys:SUMBOU,else SUM*1
	    (COND
%		(NOT (EQ '!*2 (SETQ !*N (CADR X!*))))
	       ((NOT(CDR (SETQ X!* (CADR TOT1)))))   % Several dmys:SUMBOU,else SUM*1
	       ((AND (NOT (EQ '!*2 (SETQ !*N (CADR X!*))))	% was *3 or so
		     (MEMQ !*N !*NLST) )	% avoid if not a *n,other space
		(PRINTC (LIST !*N "corrected into *2"))	%:tmpmsg
		(SETQ TOT1 (SUBST '!*2 !*N TOT1))
		(SETQ X!* (CADR TOT1)) ) )
	    (ADANS	% Push a part-program, consisting of
	     (!&SUMB (SETQ X!* (REVERSE X!*)) %SUMBOUs over dmylist X!* 
	      (MKLB DEFAULTDIMENSION!*		% Bindprotect
		(COPYT X!*)	% from these LowerBoundaries - ...
%MaKe LowrBoundaries for Revrsd DUMmyList,and Revrsd Upperbndlst,Out=RevLowBndL
		(SETQ BOUL
		 (REVERSE		% Need RevUBlist, so make that first:
%Make Upper Boundaries for dummies in Reversed DUMmyList.BOUR=(nil (Ix1.Ub1)..)
		  (MKUB (COPYT X!*) 
		   (COPYT (ADNIL (CAR (SETQ L!* (CDDR TOT1))))))))) 
	       BOUL)) )			% ... - to these UpperBoundaries(List).
%	   ((ADANS (LIST 'SUM!*1 (GTDIM (CAR X!*)) (!&NZFS (CADDDR TOT1)) )))
%	   ((ADANS (!&SUMB (CAR X!*) 0 (!&NZFS (CADDDR TOT1)) )))
	))))))))

(FLUID '(NOTC CIX ASSL))	%?? Use better names in GTSOP!

% GeT SymmetryOPerators of TSR that apply, ie have dmys on them (ie not freeix)

(DE GTSOP (TSR) 
 (PROG (ASSL SYMOP SYMO SOP NOTC)
   (OR (STGET (CAR TSR) 'SYMOP) (RETURN NIL))
   (SETQ ASSL (CDR (PAIR (SEQ0L (LENGTH TSR)) TSR)))	% Form ((1.a) (2.b)...)
  %(SETQ N 0)
  %(SETQ ASSL (MAPCAR (CDR TSR) (LAMBDAX (CONS (SETQ N (ADD1 N)) X))))
L  (SETQ SYMO (CAR SYMOP))

   (COND (DEBUG)	%:BU91 Use of hardSym now puts wrong boundaries,fix:
	 ((AND	(NOT(CDDR SYMO))   %:BU91 SYMOP /w 1 cycle, having
		(NOT(CDDADR SYMO)) ))	%:BU91	length=2: Ok.	Else Ignore it:
	 ((SETQ SYMOP (CDR SYMOP)) (GO L))	%:BU91 -by looping,or exiting
	 (T	(RETURN SOP)) )	%:BU91 Entire COND to GO when manyops fixed

   (SETQ SYMO
    (CONSCAR SYMO	% Koe
     (SUBSTFN (LAMBDAX (PROGN	% AND (ATOM X)
			   (OR  (MEMQ (SETQ X (CDR (ATSOC X ASSL))) CIX)
				(SETQ NOTC T) )
			   X))
			%(COND ((NOT (MEMQ C CIX)) (SETQ NOTC (CONS C NOTC))))
	     (CDR SYMO) )))
   (OR NOTC (SETQ SOP (CONS SYMO SOP)))
   (AND DEBUG (PRINT (LIST SYMO SOP)) (BREAK0))
   (SETQ NOTC NIL)
   (AND (SETQ SYMOP (CDR SYMOP)) (GO L))
   (RETURN SOP) ))

(DE QTCOM2 ()
 (PROG (FX NCOPY CDEF TL)
%  (SETQ GTAI1 (SETQ NCOPY (ADNIL !*NLST)))
%  (SETQ NCOPY !*NLST)			% GTAI1=Categs,set in MKBL1
%  (SETQ CIX (COPYFIRST !*NLST (LENGTH CIX)))

%  (SETQ CIX (MAPCAR CIX (LAMBDAX (PROGN
%	(SETQ FX (POP NCOPY))		% lmbdax returns fx=!*n
%	(PUTGET FX X 'INDEXTYPE)	% !*n gets dim-prop from x
%	FX))))
%  (SETQ NCOPY NIL)

   (SETQ CDEF	% Pred for SymDmys: (ORDERP !*1 !*2)=NIL in some installations,
    '(COND ((EQ ORP!#1 ORP!#2) 0)	% so must secure *1 - *2 -order by:
	   ((SETQ TL (MEMQ ORP!#1 !*NLST))	% Should always be a *n
			(MEMQ ORP!#2 TL))	% in order if 2 comes later
	   ((ORDERP ORP!#1 ORP!#2)) ))		% Shouldn't occur
   (SETQ DEF (CADR (FSIMPNOREN (CDDR DEF))))	% ****??? CHANGE? Canonicalize
		%(ADNIL (GTALG FIX DEF)) % Simp single term.

%BU91 was an alone <RIE I J I J> SYMOPing on rest of TL=nil,giving 1-1==0:So
%BU91(SETQ TL (MAPCAR (CDDR DEF) (LAMBDAX (CONS X (GTSOP X)))))
     (SETQ TL (MAPCAR (CDDR DEF) (LAMBDAX (CONS X (AND(CDDDR DEF)% -request TL
						  (GTSOP X) )))))
%BU91 but properly should use substfn that take note that dmy found in TL
%BU91 so <S I J I J<<T U U>$ -dont put I<J on T+T. Or solved by QTCFAC?(TL=NIL)

   (SETQ TL (ORDLST  %(FUNCTION(LAMBDA(X Y) (GREATERP (LENGTH X) (LENGTH Y))))
		'LONGER TL))	% Select the tsr with most active symoperators
   (SETQ GTAI1 (CDAR TL))
   (PREQ!+ (SETQ FX (CAAR TL)))
   (SETQ DEF 
    (NCONS 
     (CONSCAR DEF 
      (CONSCAR (CDR DEF) (MAPCAR (CDR TL) 'CAR)) )))
   (SETQ MKTEN NIL)	% Automatically create tsrs for part-results? Needs wrk
   (SUM!*S (LIST GTAI1 CIX (LIST (COPYL FX) DEF))) ))%Push on ANS: (SUMBOUs..)
%))

% QTCOM2.SL end
